#include gm\Variables;

Init()
{	
	LoadDefaults();
			
	config_group = GetGMVar("ConfigGroup", getdvar("gm_mode"));
	config_name = gm\Configs\FFA::Main(config_group);
	
	switch(level.gametype)
	{
	case "ffa":
		config_name = gm\Configs\FFA::Main(config_group);
		break;
	case "tdm":
		config_name = gm\Configs\TDM::Main(config_group);
		break;
	case "ctf":
		config_name = gm\Configs\CTF::Main(config_group);
		break;
	case "dom":
		config_name = gm\Configs\DOM::Main(config_group);
		break;
	case "sd":
		config_name = gm\Configs\SD::Main(config_group);
		break;
	case "sab":
		config_name = gm\Configs\SAB::Main(config_group);
		break;
	case "dem":
		config_name = gm\Configs\DEM::Main(config_group);
		break;
	case "hq":
		config_name = gm\Configs\HQ::Main(config_group);
		break;
	default:
		break;
	}
	
	if (isDefined(config_name))
	{
		[[config_name]]();
	}
	else
	{
		gm\_Util::LogError("Invalid Config Group");
	}
}

LoadDefaults()
{
	//keeping it similiar to pam for the dvars to make it easier to use
	if (getdvar("gm_mode") == "") setdvar("gm_mode", "pub");	
	
	//set all the custom things to stock default
	setdvar("gm_players_alive_hud_enabled", false);
	setdvar("gm_readyup_enabled", false);
	setdvar("gm_readyup_show_enemy_guids", false);
	setdvar("gm_main_hud_enabled", false);
	
	//knife 
	setdvar("gm_knife_autoaim_enabled", false);
	setdvar("gm_knife_autoaim_range", 128);
	setdvar("gm_knife_use_hitbox_modifiers", false);
	
	//ambient effects
	setdvar("gm_fx_ambient_sound_enabled", true);
	setdvar("gm_fx_volumetric_fog_enabled", true);
	setdvar("gm_fx_visual_enabled", true);
	
	//map specific
	setdvar("gm_map_launch_rocket_enabled", true);
	setdvar("gm_map_wmd_train_enabled", true);
	setdvar("gm_map_radiation_digger_enabled", true);
	
	//hit blips
	setdvar("gm_hitblips_enabled", true);
	setdvar("gm_hitblips_lethal_enabled", true);
	setdvar("gm_hitblips_tactical_enabled", true);
	setdvar("gm_hitblips_penetration_enabled", true);
	
	//concussion/flash settings
	setdvar("gm_concussion_radius", 512);
	setdvar("gm_concussion_max_duration", "");
	setdvar("gm_flash_max_duration", "");
	setdvar("gm_concussion_sound_enabled", true);
	setdvar("gm_flash_sound_enabled", true);
	
	//various client settings
	setdvar("gm_headbob_enabled", true);
	setdvar("gm_fall_damage_min_height", 256); //verify these defaults
	setdvar("gm_fall_damage_max_height", 480);
	setdvar("gm_allow_red_enemy_crosshairs", true);
	
	setdvar("gm_class_limits_assault", -1);
	setdvar("gm_class_limits_smg", -1);
	setdvar("gm_class_limits_lmg", -1);
	setdvar("gm_class_limits_shotgun", -1);
	setdvar("gm_class_limits_sniper", -1);
	
	setdvar("gm_equipment_starting_count", "-1");
	setdvar("gm_tactical_starting_count", "-1");
	setdvar("gm_lethal_starting_count", "-1");
		
	setdvar("gm_popups_enabled", true);
	setdvar("gm_battlechatter_enabled", true);
	setdvar("gm_silent_ads", false);
	
	setdvar("gm_restricted_weapon_drops_enabled", false);
	setdvar("gm_primary_ammo_starting_count", -1);
	setdvar("gm_sidearm_ammo_starting_count", -1);
	
	setdvar("gm_tactical_drops_enabled", true);
	setdvar("gm_lethal_drops_enabled", true);
	
	setdvar("gm_timeout_count", 0);
	setdvar("gm_timeout_duration", 60);
	
	setdvar("gm_sv_cheats_notifier", false);
	setdvar("gm_event_notifications", false);
	
	LoadHitboxDamageModifierDefaults();
	LoadLoadoutDefaults();
	LoadGametypeDefaults();
}

LoadLoadoutDefaults()
{
	//attachments
	setdvar("gm_attachments_allow_silencer", true);
	setdvar("gm_attachments_allow_grip", true);
	setdvar("gm_attachments_allow_extended_mags", true);
	setdvar("gm_attachments_allow_reddot", true);
	setdvar("gm_attachments_allow_reflex", true);
	setdvar("gm_attachments_allow_dual_mags", true);
	setdvar("gm_attachments_allow_acog", true);	
	setdvar("gm_attachments_allow_masterkey", true);	
	setdvar("gm_attachments_allow_flamethrower", true);	
	setdvar("gm_attachments_allow_infared", true);	
	setdvar("gm_attachments_allow_gren_launcher", true);	
	setdvar("gm_attachments_allow_var_zoom", true);	
	setdvar("gm_attachments_allow_dual_wield", true);	
	setdvar("gm_attachments_allow_rapid_fire", true);	
	//pistol attachments
	setdvar("gm_attachments_allow_snub_nose", true);
	setdvar("gm_attachments_allow_speed_reloader", true);
	setdvar("gm_attachments_allow_full_auto_upg", true);
	setdvar("gm_attachments_allow_upg_iron_sights", true);
	
	//lethal
	setdvar("gm_lethal_allow_frag", true);
	setdvar("gm_lethal_allow_semtex", true);
	setdvar("gm_lethal_allow_tomahawk", true);
	//tactical
	setdvar("gm_tactical_allow_willy_pete", true);
	setdvar("gm_tactical_allow_nova_gas", true);
	setdvar("gm_tactical_allow_flashbang", true);
	setdvar("gm_tactical_allow_concussion", true);
	setdvar("gm_tactical_allow_decoy", true);
	//equipment
	setdvar("gm_equipment_allow_camera_spike", true);
	setdvar("gm_equipment_allow_c4", true);
	setdvar("gm_equipment_allow_tac_insert", true);
	setdvar("gm_equipment_allow_jammer", true);
	setdvar("gm_equipment_allow_motion_sensor", true);
	setdvar("gm_equipment_allow_claymore", true);
	
	//weapons
	//AR
	setdvar("gm_assault_allow_ak47", true);
	setdvar("gm_assault_allow_aug", true);
	setdvar("gm_assault_allow_commando", true);
	setdvar("gm_assault_allow_enfield", true);
	setdvar("gm_assault_allow_famas", true);
	setdvar("gm_assault_allow_fnfal", true);
	setdvar("gm_assault_allow_galil", true);
	setdvar("gm_assault_allow_m14", true);
	setdvar("gm_assault_allow_m16", true);
	setdvar("gm_assault_allow_g11", true);
	
	//Shotgun
	setdvar("gm_shotgun_allow_olympia", true);
	setdvar("gm_shotgun_allow_spas", true);
	setdvar("gm_shotgun_allow_stakeout", true);
	setdvar("gm_shotgun_allow_hs10", true);
	
	//Lmg
	setdvar("gm_lmg_allow_hk21", true);
	setdvar("gm_lmg_allow_m60", true);
	setdvar("gm_lmg_allow_rpk", true);
	setdvar("gm_lmg_allow_stoner63", true);
	
	//Smg
	setdvar("gm_smg_allow_ak74u", true);
	setdvar("gm_smg_allow_kiparis", true);
	setdvar("gm_smg_allow_mac11", true);
	setdvar("gm_smg_allow_mp5k", true);
	setdvar("gm_smg_allow_mpl", true);
	setdvar("gm_smg_allow_skorpion", true);
	setdvar("gm_smg_allow_spectre", true);
	setdvar("gm_smg_allow_uzi", true);
	setdvar("gm_smg_allow_pm63", true);
	
	//Sniper
	setdvar("gm_sniper_allow_dragunov", true);
	setdvar("gm_sniper_allow_l96a1", true);
	setdvar("gm_sniper_allow_wa2000", true);
	setdvar("gm_sniper_allow_psg1", true);
	
	//secondary
	//pistols
	setdvar("gm_pistol_allow_asp", true);
	setdvar("gm_pistol_allow_cz75", true);
	setdvar("gm_pistol_allow_m1911", true);
	setdvar("gm_pistol_allow_python", true);
	setdvar("gm_pistol_allow_makarov", true);
	
	//launchers
	setdvar("gm_launcher_allow_china_lake", true);
	setdvar("gm_launcher_allow_rpg", true);
	setdvar("gm_launcher_allow_strela", true);
	setdvar("gm_launcher_allow_m72", true);
		
	//special
	setdvar("gm_special_allow_ballistic_knife", true);
	setdvar("gm_special_allow_crossbow", true);
	
	LoadPerkDefaults();
}

LoadHitboxDamageModifierDefaults()
{
	//hitbox damage modifiers
	setdvar("gm_hitbox_damage_mod_enabled", false);
	setdvar("gm_hitbox_damage_mod_helmet", 1.0);
	setdvar("gm_hitbox_damage_mod_head", 1.0);
	setdvar("gm_hitbox_damage_mod_neck", 1.0);
	setdvar("gm_hitbox_damage_mod_torso_upper", 1.0);
	setdvar("gm_hitbox_damage_mod_right_arm_upper", 1.0);
	setdvar("gm_hitbox_damage_mod_left_arm_upper", 1.0);
	setdvar("gm_hitbox_damage_mod_right_arm_lower", 1.0);
	setdvar("gm_hitbox_damage_mod_left_arm_lower", 1.0);
	setdvar("gm_hitbox_damage_mod_right_hand", 1.0);
	setdvar("gm_hitbox_damage_mod_left_hand", 1.0);
	setdvar("gm_hitbox_damage_mod_gun", 1.0);
	setdvar("gm_hitbox_damage_mod_torso_lower", 1.0);
	setdvar("gm_hitbox_damage_mod_right_leg_upper", 1.0);
	setdvar("gm_hitbox_damage_mod_left_leg_upper", 1.0);
	setdvar("gm_hitbox_damage_mod_right_leg_lower", 1.0);
	setdvar("gm_hitbox_damage_mod_left_leg_lower", 1.0);
	setdvar("gm_hitbox_damage_mod_right_foot", 1.0);
	setdvar("gm_hitbox_damage_mod_left_foot", 1.0);
}

LoadPerkDefaults()
{
	setdvar("gm_specialty_allow_armorpiercing", true);
	setdvar("gm_specialty_allow_armorvest", true);
	setdvar("gm_specialty_allow_bulletaccuracy", true);
	setdvar("gm_specialty_allow_bulletdamage", true);
	setdvar("gm_specialty_allow_bulletflinch", true);
	setdvar("gm_specialty_allow_bulletpenetration", true);
	setdvar("gm_specialty_allow_copycat", true);
	setdvar("gm_specialty_allow_delayexplosive", true);
	setdvar("gm_specialty_allow_detectexplosive", true);
	setdvar("gm_specialty_allow_disarmexplosive", true);
	setdvar("gm_specialty_allow_explosivedamage", true);
	setdvar("gm_specialty_allow_extraammo", true);
	setdvar("gm_specialty_allow_extramoney", true);
	setdvar("gm_specialty_allow_fallheight", true);
	setdvar("gm_specialty_allow_fastads", true);
	setdvar("gm_specialty_allow_fastinteract", true);
	setdvar("gm_specialty_allow_fastmantle", true);
	setdvar("gm_specialty_allow_fastmeleerecovery", true);
	setdvar("gm_specialty_allow_fastreload", true);
	setdvar("gm_specialty_allow_fastweaponswitch", true);
	setdvar("gm_specialty_allow_finalstand", true);
	setdvar("gm_specialty_allow_fireproof", true);
	setdvar("gm_specialty_allow_flakjacket", true);
	setdvar("gm_specialty_allow_gambler", true);
	setdvar("gm_specialty_allow_gas_mask", true);
	setdvar("gm_specialty_allow_gpsjammer", true);
	setdvar("gm_specialty_allow_grenadepulldeath", true);
	setdvar("gm_specialty_allow_healthregen", true);
	setdvar("gm_specialty_allow_holdbreath", true);
	setdvar("gm_specialty_allow_killstreak", true);
	setdvar("gm_specialty_allow_longersprint", true);
	setdvar("gm_specialty_allow_loudenemies", true);
	setdvar("gm_specialty_allow_movefaster", true);
	setdvar("gm_specialty_allow_nomotionsensor", true);
	setdvar("gm_specialty_allow_noname", true);
	setdvar("gm_specialty_allow_nottargetedbyai", true);
	setdvar("gm_specialty_allow_pin_back", true);
	setdvar("gm_specialty_allow_pistoldeath", true);
	setdvar("gm_specialty_allow_quieter", true);
	setdvar("gm_specialty_allow_reconnaissance", true);
	setdvar("gm_specialty_allow_rof", true);
	setdvar("gm_specialty_allow_scavenger", true);
	setdvar("gm_specialty_allow_shades", true);
	setdvar("gm_specialty_allow_shellshock", true);
	setdvar("gm_specialty_allow_showenemyequipment", true);
	setdvar("gm_specialty_allow_showonradar", true);
	setdvar("gm_specialty_allow_sprintrecovery", true);
	setdvar("gm_specialty_allow_stunprotection", true);
	setdvar("gm_specialty_allow_twoattach", true);
	setdvar("gm_specialty_allow_twogrenades", true);
	setdvar("gm_specialty_allow_twoprimaries", true);
	setdvar("gm_specialty_allow_unlimitedsprint", true);
}

LoadGametypeDefaults()
{
	setdvar("gm_overtime_enabled", false);
	
	setdvar("gm_ctf_allow_flag_drop", false);	
	setdvar("gm_ctf_round_based_scoring", true);
	setdvar("gm_ctf_ot_suddendeath", 1);
	
	setdvar("gm_tdm_round_based_scoring", true);
	setdvar("gm_dom_round_based_scoring", true);
	setdvar("gm_koth_round_based_scoring", true);	
		
	setdvar("gm_sd_allow_bomb_drop", false);
	setdvar("gm_sd_hide_briefcase", false);	
	setdvar("gm_sd_sounds_plant_enabled", false);	
	setdvar("gm_sd_sounds_defuse_enabled", false);
	setdvar("gm_sd_sounds_plant_looptime", 1.5);
	setdvar("gm_sd_sounds_defuse_looptime", 1.5);
	setdvar("gm_sd_strat_time", 0);
	
	setdvar("gm_sab_allow_bomb_drop", false);
	setdvar("gm_sab_hide_briefcase", false);
	setdvar("gm_sab_sounds_plant_enabled", false);
	setdvar("gm_sab_sounds_defuse_enabled", false);
	setdvar("gm_sab_sounds_plant_looptime", 1.5);	
	setdvar("gm_sab_sounds_defuse_looptime", 1.5);	
	setdvar("gm_sab_show_2D_bombsites", true);
	setdvar("gm_sab_show_3D_bombsites", true);
	setdvar("gm_sab_comp_mode_enabled", false);
	setdvar("gm_sab_comp_mode_spawnincrease", 5);
	setdvar("gm_sab_comp_mode_maxspawntime", 60);
	setdvar("gm_sab_comp_mode_incrementtime", 60);
	setdvar("gm_sab_enemy_bomb_carrier_visible", true);	
	
	setdvar("gm_dem_hide_briefcase", false);
	setdvar("gm_dem_sounds_plant_enabled", false);
	setdvar("gm_dem_sounds_defuse_enabled", false);	
	setdvar("gm_dem_sounds_plant_looptime", 1.5);
	setdvar("gm_dem_sounds_defuse_looptime", 1.5);	
}

