#include gm\_Util;
#include gm\Variables;

TriggerEvent(Event, Player)
{
	if (!GetGMVar("gm_event_notifications", false))
		return;
		
	team_notification = "";
	enemy_notification = "";
	
	team = Player.pers["team"];
	
	switch(Event)
	{
		case "ctf_pickup":
			team_notification = Player.name + " has taken the flag";
			enemy_notification = "Your flag was taken";
			break;
		case "ctf_capture":
			team_notification = Player.name + " has captured the flag";
			enemy_notification = "Your flag was captured";
			break;
		case "ctf_return":
			team_notification = Player.name + " has returned the flag";
			enemy_notification = "Enemy flag was returned";
			break;
		case "ctf_dropped":
			team_notification = "Enemy flag was dropped";
			enemy_notification = "Your flag was dropped";
			break;
		case "sd_planted":
		case "sab_planted":
		case "dem_planted":
			team_notification = Player.name + " planted the bomb";
			enemy_notification = "Bomb planted";
			break;
		case "sd_defused":
		case "sab_defused":
		case "dem_defused":
			team_notification = Player.name + " defused the bomb";
			enemy_notification = "Bomb defused";
			break;		
		case "koth_captured":
			team_notification = "Headquarters captured";
			enemy_notification = "Enemy captured headquarters";
			break;
		case "koth_destroyed":
			team_notification = "Headquarters destroyed";
			enemy_notification = "Enemy destroyed headquarters";
			break;
		default:
			LogError("invalid event triggered");
			return;
	}
	
	for ( i = 0; i < level.players.size; i++ )
	{
		if ( isDefined( level.players[i].pers["team"] ))
		{
			player_team = level.players[i].pers["team"];
			if (player_team == team || player_team == "specatator")
			{
				level.players[i] iprintln("^1" + team_notification);
			}	
			else
			{
				level.players[i] iprintln("^1" + enemy_notification);
			}
		}
	}
	
	LogInfo(team_notification);
}