#include gm\_Util;
#include gm\Variables;

Init()
{		
	gm\Variables::InitVariables();
	gm\Configs::Init();	
	if (!GetGMVar("gm_dvars_read", false))
	{
		gm\Variables::ReadDvars();
		gm\Timeout::TimeoutInit();
	}
	
	gm\HUD::Init();	
	
	gm\Variables::AddDvarMonitor("gm_mode", gm\GM::OnModeChanged);
	thread gm\Variables::MonitorDvars();
	gm\Variables::SetupClientDvarMonitoring();
	
	gm\Client::Main();
	
	if (GetGMVar("gm_players_alive_hud_enabled", false))
		gm\PlayersAlive::Main();
		
	if (GetGMVar("gm_sv_cheats_notifier", false))
		thread GMSvCheatsNotifier();
}

OnModeChanged(Dvar, OldVal, NewVal)
{
	// valid
	//restart map with new settings
	NotifyUser("Loading configs for: " + NewVal);
	wait 2;
				
	SetGMVar("ConfigGroup", NewVal);
	SetGMVar("gm_dvars_read", false);
				
	map_restart(true);
				
	return true;
}

GMSvCheatsNotifier()
{
	cheats_enabled = false;
	cheat_hud = undefined;
	
	while(true)
	{
		if (!cheats_enabled && getdvarint("sv_cheats") == 1)
		{
			cheat_hud = gm\HUD::CreateHUDElement(320, 20, "center", "middle", "default", 2, true, "WARNING: SV_CHEATS = 1", (1, 0, 0));
		}
		else if (cheats_enabled && getdvarint("sv_cheats") == 0)
		{
			if (isDefined(cheat_hud))
				cheat_hud destroy();
		}
		wait .1;
	}
}
