#include gm\_Util;

Init()
{
	level.HudElements = [];
	
	if (gm\Variables::GetGMVar("gm_main_hud_enabled", false))
	{
		text = gm\Variables::GetGMVar("gm_version") + " - " + getdvar("gm_mode") + " mode";
		AddHUDElement("version_hud", CreateHUDElement(640, 40, "right", "top", "default", 1.0, true, text, (0, 1, 0)));
	}
}

CreateHUDElement(X, Y, AlignX, AlignY, Font, FontScale, HideWhenInMenu, Text, Color)
{
	hud_element = NewHudElem();
	// AlignX is what direction x is in relation to the text (left, center, right)
	hud_element.alignX = AlignX;
	// AlignY is what direction y is in relation to the text (top, middle, bottom)
	hud_element.alignY = AlignY;
	
	hud_element.color = Color;
	
	//x, y position of the element on the screen (640 x 480)
	hud_element.x = X;
	hud_element.y = Y;
	
	hud_element.font = Font;
	hud_element.fontScale = FontScale;
	
	hud_element.hidewheninmenu = HideWhenInMenu;
	hud_element SetText(Text);
	
	return hud_element;
}

CreateClientHUDElement(Client, X, Y, AlignX, AlignY, Font, FontScale, HideWhenInMenu, Text, Color)
{
	hud_element = NewClientHudElem(Client);
	// AlignX is what direction x is in relation to the text (left, center, right)
	hud_element.alignX = AlignX;
	// AlignY is what direction y is in relation to the text (top, middle, bottom)
	hud_element.alignY = AlignY;
	
	hud_element.color = Color;
	
	//x, y position of the element on the screen (640 x 480)
	hud_element.x = X;
	hud_element.y = Y;
	
	hud_element.font = Font;
	hud_element.fontScale = FontScale;
	
	hud_element.hidewheninmenu = HideWhenInMenu;
	hud_element SetText(Text);
	
	return hud_element;
}

AddHUDElement(Name, Element)
{
	if (isDefined(level.HudElements[Name]))
	{
		LogError("HUD Element: " + Name + " already exists");
		return;
	}
	else
	{		
		level.HudElements[Name] = Element;
		LogInfo("HUD Element: " + Name + " added");
	}
}

RemoveHUDElement(Name)
{
	if (isDefined(level.HudElements[Name]))
	{
		level.HudElements[Name] destroy();
		LogInfo("HUD Element: " + Name + " destroyed");
		return true;
	}
	return false;
}

GetHUDElement(Name)
{
	//log error is not defined
	return level.HudElements[Name];
}

AddPlayerHUDElement(Name, Element)
{
	if (!isDefined(self.HudElements))
	{
		self.HudElements = [];
	}
	
	if (isDefined(self.HudElements[Name]))
	{
		LogError("Player HUD Element: " + Name + " already exists");
		return;
	}
	else
	{		
		self.HudElements[Name] = Element;
		LogInfo("Player HUD Element: " + Name + " added");
	}
}

RemovePlayerHUDElement(Name)
{
	if (isDefined(self.HudElements[Name]))
	{
		self.HudElements[Name] destroy();
		LogInfo("Player HUD Element: " + Name + " destroyed");
		return true;
	}
	return false;
}

GetPlayerHUDElement(Name)
{
	//log error is not defined
	return self.HudElements[Name];
}

