#include gm\Variables;
#include gm\_Util;

VerifyLoadout(Loadout)
{
	if (!CheckLoadoutLimits("primary", Loadout["primary"]))
	{
		LogInfo("bad primary = " + Loadout["primary"]);
		return false;
	}
		
	if (!CheckLoadoutLimits("attachment", Loadout["primary"]))
	{
		LogInfo("bad primary attachments");
		return false;
	}
		
	if (!CheckLoadoutLimits("sidearm", Loadout["secondary"]))
	{
		LogInfo("bad secondary");
		return false;
	}
		
	if (!CheckLoadoutLimits("attachment", Loadout["secondary"]))
	{
		LogInfo("bad secondary atachments");
		return false;
	}
		
	//TODO: fix, this throws a bunch of runtime errors
	/*if (!VerifyPerks(Loadout["specialties"]))
	{
		LogInfo("bad perks");
		return false;
	}*/
		
	if (!CheckLoadoutLimits("tactical", Loadout["special_grenade"]))
	{
		LogInfo("bad tacticals");
		return false;
	}
		
	if (!CheckLoadoutLimits("equipment", Loadout["equipment_slot"]))
	{
		LogInfo("bad equipment");
		return false;
	}
		
	if (!CheckLoadoutLimits("lethal", Loadout["primary_grenades"]))
	{
		LogInfo("bad lethals");
		return false;
	}	
		
	return true;
}

VerifyAttachments(Weapon)
{
	//map each dvar to a substring in the weapon name
	checks = [];
	checks["gm_attachments_allow_silencer"] = "silencer_";
	checks["gm_attachments_allow_grip"] = "grip_";
	checks["gm_attachments_allow_extended_mags"] = "extclip_";
	checks["gm_attachments_allow_reddot"] = "elbit";
	checks["gm_attachments_allow_reflex"] = "reflex_";
	checks["gm_attachments_allow_dual_mags"] = "dualclip_";
	checks["gm_attachments_allow_acog"] = "acog_";	
	checks["gm_attachments_allow_masterkey"] = "mk_";	
	checks["gm_attachments_allow_flamethrower"] = "ft_";	
	checks["gm_attachments_allow_infared"] = "ir_";	
	checks["gm_attachments_allow_gren_launcher"] = "gl_";	
	checks["gm_attachments_allow_var_zoom"] = "vzoom_";	
	checks["gm_attachments_allow_dual_wield"] = "dw_";		
	checks["gm_attachments_allow_rapid_fire"] = "rf_";	
	checks["gm_attachments_allow_snub_nose"] = "snub_";	
	checks["gm_attachments_allow_speed_reloader"] = "speed_";	
	checks["gm_attachments_allow_full_auto_upg"] = "auto_";	
	checks["gm_attachments_allow_upg_iron_sights"] = "upgradesight_";	
	
	keys = GetArrayKeys(checks);
	
	for (i = 0; i < keys.size; i++)
	{
		if (isSubStr(Weapon, checks[keys[i]]))
			return GetGMVar(keys[i], 99);		
	}
	
	return 99;
}

VerifyPerks(Perks)
{
	for (i = 0; i < Perks.size; i++)
	{
		if (!CheckLoadoutLimits("perk", Perks[i]))
			return false;
	}
	return true;
}

VerifyPerk(Perk)
{
	checks = [];
	checks["gm_specialty_allow_armorpiercing"] = "speciality_armorpiercing";
	checks["gm_specialty_allow_armorvest"] = "speciality_armorvest";
	checks["gm_specialty_allow_bulletaccuracy"] = "speciality_bulletaccuracy";
	checks["gm_specialty_allow_bulletdamage"] = "speciality_bulletdamage";
	checks["gm_specialty_allow_bulletflinch"] = "speciality_bulletflinch";
	checks["gm_specialty_allow_bulletpenetration"] = "speciality_bulletpenetration";
	checks["gm_specialty_allow_copycat"] = "speciality_copycat";
	checks["gm_specialty_allow_delayexplosive"] = "speciality_delayexplosive";
	checks["gm_specialty_allow_detectexplosive"] = "speciality_detectexplosive";
	checks["gm_specialty_allow_disarmexplosive"] = "speciality_disarmexplosive";
	checks["gm_specialty_allow_explosivedamage"] = "speciality_explosivedamage";
	checks["gm_specialty_allow_extraammo"] = "speciality_extraammo";
	checks["gm_specialty_allow_extramoney"] = "speciality_extramoney";
	checks["gm_specialty_allow_fallheight"] = "speciality_fallheight";
	checks["gm_specialty_allow_fastads"] = "speciality_fastads";
	checks["gm_specialty_allow_fastinteract"] = "speciality_fastinteract";
	checks["gm_specialty_allow_fastmantle"] = "speciality_fastmantle";
	checks["gm_specialty_allow_fastmeleerecovery"] = "speciality_fastmeleerecovery";
	checks["gm_specialty_allow_fastreload"] = "speciality_fastreload";
	checks["gm_specialty_allow_fastweaponswitch"] = "speciality_fastweaponswitch";
	checks["gm_specialty_allow_finalstand"] = "speciality_finalstand";
	checks["gm_specialty_allow_fireproof"] = "speciality_fireproof";
	checks["gm_specialty_allow_flakjacket"] = "speciality_flakjacket";
	checks["gm_specialty_allow_gambler"] = "speciality_gambler";
	checks["gm_specialty_allow_gas_mask"] = "speciality_gas_mask";
	checks["gm_specialty_allow_gpsjammer"] = "speciality_gpsjammer";
	checks["gm_specialty_allow_grenadepulldeath"] = "speciality_grenadepulldeath";
	checks["gm_specialty_allow_healthregen"] = "speciality_healthregen";
	checks["gm_specialty_allow_holdbreath"] = "speciality_holdbreath";
	checks["gm_specialty_allow_killstreak"] = "speciality_killstreak";
	checks["gm_specialty_allow_longersprint"] = "speciality_longersprint";
	checks["gm_specialty_allow_loudenemies"] = "speciality_loudenemies";
	checks["gm_specialty_allow_movefaster"] = "speciality_movefaster";
	checks["gm_specialty_allow_nomotionsensor"] = "speciality_nomotionsensor";
	checks["gm_specialty_allow_noname"] = "speciality_noname";
	checks["gm_specialty_allow_nottargetedbyai"] = "speciality_nottartedbyai";
	checks["gm_specialty_allow_pin_back"] = "speciality_pin_back";
	checks["gm_specialty_allow_pistoldeath"] = "speciality_pistoldeath";
	checks["gm_specialty_allow_quieter"] = "speciality_quieter";
	checks["gm_specialty_allow_reconnaissance"] = "speciality_reconnaissance";
	checks["gm_specialty_allow_rof"] = "speciality_rof";
	checks["gm_specialty_allow_scavenger"] = "speciality_scavenger";
	checks["gm_specialty_allow_shades"] = "speciality_shades";
	checks["gm_specialty_allow_shellshock"] = "speciality_shellshock";
	checks["gm_specialty_allow_showenemyequipment"] = "speciality_showenemyequipment";
	checks["gm_specialty_allow_showonradar"] = "speciality_showonradar";
	checks["gm_specialty_allow_sprintrecovery"] = "speciality_sprintrecovery";
	checks["gm_specialty_allow_stunprotection"] = "speciality_stunprotection";
	checks["gm_specialty_allow_twoattach"] = "speciality_twoattach";
	checks["gm_specialty_allow_twogrenades"] = "speciality_twogrenades";
	checks["gm_specialty_allow_twoprimaries"] = "speciality_twoprimaries";
	checks["gm_specialty_allow_unlimitedsprint"] = "speciality_unlimitedsprint";
	
	keys = GetArrayKeys(checks);
	
	for (i = 0; i < keys.size; i++)
	{
		if (Perk == checks[keys[i]])
			return GetGMVar(keys[i], 99);		
	}
	
	return 99;
}

VerifyEquipment(Equipment)
{
	checks = [];
	checks["gm_equipment_allow_camera_spike"] = "camera_spike_mp";
	checks["gm_equipment_allow_c4"] = "satchel_charge_mp";
	checks["gm_equipment_allow_tac_insert"] = "tactical_insertion_mp";
	checks["gm_equipment_allow_jammer"] = "scrambler_mp";
	checks["gm_equipment_allow_motion_sensor"] = "acoustic_sensor_mp";
	checks["gm_equipment_allow_claymore"] = "claymore_mp";	
	
	keys = GetArrayKeys(checks);
	
	for (i = 0; i < keys.size; i++)
	{
		if (Equipment == checks[keys[i]])
			return GetGMVar(keys[i], 99);		
	}
	
	return 99;
}

VerifyTactical(Tactical)
{
	checks = [];
	checks["gm_tactical_allow_willy_pete"] = "willy_pete_mp";
	checks["gm_tactical_allow_nova_gas"] = "tabun_gas_mp";
	checks["gm_tactical_allow_flashbang"] = "flash_grenade_mp";
	checks["gm_tactical_allow_concussion"] = "concussion_grenade_mp";
	checks["gm_tactical_allow_decoy"] = "nightingale_mp";
	
	keys = GetArrayKeys(checks);
	
	for (i = 0; i < keys.size; i++)
	{
		if (Tactical == checks[keys[i]])
			return GetGMVar(keys[i], 99);		
	}
	
	return 99;
}

VerifyLethal(Lethal)
{
	checks = [];
	checks["gm_lethal_allow_frag"] = "frag_grenade_mp";
	checks["gm_lethal_allow_semtex"] = "sticky_grenade_mp";
	checks["gm_lethal_allow_tomahawk"] = "hatchet_mp";	
	
	keys = GetArrayKeys(checks);
	
	for (i = 0; i < keys.size; i++)
	{
		if (Lethal == checks[keys[i]])
			return GetGMVar(keys[i], 99);		
	}
	
	return 99;
}

VerifyPrimaryWeapon(Weapon)
{
	checks = [];
	checks["gm_assault_allow_ak47"] = "ak47_";
	checks["gm_assault_allow_aug"] = "aug_";
	checks["gm_assault_allow_commando"] = "commando_";	
	checks["gm_assault_allow_enfield"] = "enfield_";
	checks["gm_assault_allow_famas"] = "famas_";
	checks["gm_assault_allow_fnfal"] = "fnfal_";
	checks["gm_assault_allow_galil"] = "galil_";
	checks["gm_assault_allow_m14"] = "m14_";
	checks["gm_assault_allow_m16"] = "m16_";
	checks["gm_assault_allow_g11"] = "g11_";	
	
	checks["gm_shotgun_allow_olympia"] = "rottweil72_";
	checks["gm_shotgun_allow_spas"] = "spas_";
	checks["gm_shotgun_allow_stakeout"] = "ithaca_";
	checks["gm_shotgun_allow_hs10"] = "hs10";
	
	checks["gm_lmg_allow_hk21"] = "hk21_";
	checks["gm_lmg_allow_m60"] = "m60_";
	checks["gm_lmg_allow_rpk"] = "rpk_";
	checks["gm_lmg_allow_stoner63"] = "stoner63_";
	
	checks["gm_smg_allow_ak74u"] = "ak74u_";
	checks["gm_smg_allow_kiparis"] = "kiparis_";
	checks["gm_smg_allow_mac11"] = "mac11_";
	checks["gm_smg_allow_mp5k"] = "mp5k_";
	checks["gm_smg_allow_mpl"] = "mpl_";
	checks["gm_smg_allow_skorpion"] = "skorpion_";
	checks["gm_smg_allow_spectre"] = "spectre_";
	checks["gm_smg_allow_uzi"] = "uzi_";
	checks["gm_smg_allow_pm63"] = "pm63_";		
	
	checks["gm_sniper_allow_dragunov"] = "dragunov_";
	checks["gm_sniper_allow_l96a1"] = "l96a1_";
	checks["gm_sniper_allow_wa2000"] = "wa2000_";
	checks["gm_sniper_allow_psg1"] = "psg1_";
	
	keys = GetArrayKeys(checks);
	
	for (i = 0; i < keys.size; i++)
	{
		if (isSubStr(Weapon, checks[keys[i]]))
			return GetGMVar(keys[i], 99);		
	}
	
	return 99;
}

VerifySidearm(Sidearm)
{
	checks = [];
	checks["gm_pistol_allow_asp"] = "asp";		
	checks["gm_pistol_allow_cz75"] = "cz75";
	checks["gm_pistol_allow_m1911"] = "m1911";
	checks["gm_pistol_allow_python"] = "python"; 
	checks["gm_pistol_allow_makarov"] = "makarov_";
	
	checks["gm_launcher_allow_china_lake"] = "china_lake_";
	checks["gm_launcher_allow_rpg"] = "rpg_";
	checks["gm_launcher_allow_strela"] = "strela_";
	checks["gm_launcher_allow_m72"] = "m72_";
	
	checks["gm_special_allow_crossbow"] = "crossbow_";
	checks["gm_special_allow_ballistic_knife"] = "knife_ballistic_";	
	
	keys = GetArrayKeys(checks);
	
	for (i = 0; i < keys.size; i++)
	{
		if (isSubStr(Sidearm, checks[keys[i]]))
			return GetGMVar(keys[i], 99);		
	}
	
	return 99;
}

ClassifyWeapon(Weapon)
{
	checks = [];
	checks["ak47_"] = "assault";
	checks["aug_"] = "assault";
	checks["commando_"] = "assault";
	checks["enfield_"] = "assault";
	checks["famas_"] = "assault";
	checks["fnfal_"] = "assault";
	checks["galil_"] = "assault";
	checks["m14_"] = "assault";
	checks["m16_"] = "assault";
	checks["g11_"] = "assault";
	
	checks["rottweil72_"] = "shotgun";
	checks["spas_"] = "shotgun";
	checks["ithaca_"] = "shotgun";
	checks["hs10"] = "shotgun";
	
	checks["hk21_"] = "lmg";
	checks["m60_"] = "lmg";
	checks["rpk_"] = "lmg";
	checks["stoner63_"] = "lmg";
	
	checks["ak74u_"] = "smg";
	checks["kiparis_"] = "smg";
	checks["mac11_"] = "smg";
	checks["mp5k_"] = "smg";
	checks["mpl_"] = "smg";
	checks["skorpion_"] = "smg";
	checks["spectre_"] = "smg";
	checks["uzi_"] = "smg";
	checks["pm63_"] = "smg";		
	
	checks["dragunov_"] = "sniper";
	checks["l96a1_"] = "sniper";
	checks["wa2000_"] = "sniper";
	checks["psg1_"] = "sniper";
	
	keys = GetArrayKeys(checks);
	
	for (i = 0; i < keys.size; i++)
	{	
		if (isSubStr(Weapon, keys[i]))
			return checks[keys[i]];		
	}
}

CheckClassLimits(Weapon)
{
	weapon_class = ClassifyWeapon(Weapon);
	
	switch(weapon_class)
	{
		case "assault":
		{
			limit = GetGMVar("gm_class_limits_assault", -1);
			if (limit > -1)
			{
				current = self GetCurrentClassCount(weapon_class);
				if (current >= limit)
					return false;
			}
			return true;
		}
		case "smg":
		{
			limit = GetGMVar("gm_class_limits_smg", -1);
			if (limit > -1)
			{
				current = self GetCurrentClassCount(weapon_class);
				if (current >= limit)
					return false;
			}
			return true;
		}
		case "lmg":
		{
			limit = GetGMVar("gm_class_limits_lmg", -1);
			if (limit > -1)
			{
				current = self GetCurrentClassCount(weapon_class);
				if (current >= limit)
					return false;
			}
			return true;
		}
		case "sniper":
		{
			limit = GetGMVar("gm_class_limits_shotgun", -1);
			if (limit > -1)
			{
				current = self GetCurrentClassCount(weapon_class);
				if (current >= limit)
					return false;
			}
			return true;
		}
		case "shotgun":
		{
			limit = GetGMVar("gm_class_limits_sniper", -1);
			if (limit > -1)
			{
				current = self GetCurrentClassCount(weapon_class);
				if (current >= limit)
					return false;
			}
			return true;
		}
	}
}

GetCurrentClassCount(WeaponClass)
{
	players = getentarray("player", "classname");
	
	count = 0;

	team = self.pers["team"];
	// Go through all the players
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		if (self == player || team != player.pers["team"])
			continue;
			
		if (WeaponClass == ClassifyWeapon(player.pers["primaryWeapon"]))
			count++;
	}
	
	return count;
}

GetLoadoutSearchString(LoadoutCategory, Name)
{
	checks = [];
	switch(LoadoutCategory)
	{
		case "primary":
		{
			checks[0] = "ak47_";
			checks[1] = "aug_";
			checks[2] = "commando_";
			checks[3] = "enfield_";
			checks[4] = "famas_";
			checks[5] = "fnfal_";
			checks[6] = "galil_";
			checks[7] = "m14_";
			checks[8] = "m16_";
			checks[9] = "g11_";
			checks[10] = "rottweil72_";
			checks[11] = "spas_";
			checks[12] = "ithaca_";
			checks[13] = "hs10";
			checks[14] = "hk21_";
			checks[15] = "m60_";
			checks[16] = "rpk_";
			checks[17] = "stoner63_";
			checks[18] = "ak74u_";
			checks[19] = "kiparis_";
			checks[20] = "mac11_";
			checks[21] = "mp5k_";
			checks[22] = "mpl_";
			checks[23] = "skorpion_";
			checks[24] = "spectre_";
			checks[25] = "uzi_";
			checks[26] = "pm63_";
			checks[27] = "dragunov_";
			checks[28] = "l96a1_";
			checks[29] = "wa2000_";
			checks[30] = "psg1_";
			break;
		}
		case "sidearm":
		{
			checks[0] = "asp";
			checks[1] = "cz75";
			checks[2] = "m1911";
			checks[3] = "python";
			checks[4] = "makarov_";
			checks[5] = "china_lake_";
			checks[6] = "rpg_";
			checks[7] = "strela_";
			checks[8] = "m72_";
			checks[9] = "crossbow_";
			checks[10] = "knife_ballistic_";
			
			break;
		}
		case "attachment":
		{
			checks[0] = "silencer_";
			checks[1] = "grip_";
			checks[2] = "extclip_";
			checks[3] = "elbit";
			checks[4] = "reflex_";
			checks[5] = "dualclip_";
			checks[6] = "acog_";
			checks[7] = "mk_";
			checks[8] = "ft_";
			checks[9] = "ir_";
			checks[10] = "gl_";
			checks[11] = "vzoom_";
			checks[12] = "dw_";
			checks[13] = "rf_";
			checks[14] = "snub_";
			checks[15] = "speed_";
			checks[16] = "auto_";
			checks[17] = "upgradesight_";
			break;
		}
	}
	
	if (isDefined(checks))
	{
		for(i = 0; i < checks.size; i++)
		{
			if (isSubStr(Name, checks[i]))
				return checks[i];
		}
	}
	
	return "";
}

CheckLoadoutLimits(LoadoutCategory, Val)
{	
	LoadoutCategory = tolower(LoadoutCategory);
	
	allowed = 0;
	count = 0;
	
	switch(LoadoutCategory)
	{
		case "primary":
		{
			allowed = VerifyPrimaryWeapon(Val);
			if (allowed > 0)
			{
				search_str = GetLoadoutSearchString(LoadoutCategory, Val);
				count = self GetCurrentLoadoutCount(LoadoutCategory, search_str);
			}
			else
				return false;
				
			break;			
		}
		case "sidearm":
		{
			allowed = VerifySidearm(Val);
			if (allowed > 0)
			{
				search_str = GetLoadoutSearchString(LoadoutCategory, Val);
				count = self GetCurrentLoadoutCount(LoadoutCategory, search_str);
			}
			else
				return false;
			break;
		}
		case "lethal":
		{
			allowed = VerifyLethal(Val);
			if (allowed > 0)
			{
				count = self GetCurrentLoadoutCount(LoadoutCategory, Val);
			}
			else
				return false;
			break;
		}
		case "tactical":
		{
			allowed = VerifyTactical(Val);
			if (allowed > 0)
			{
				count = self GetCurrentLoadoutCount(LoadoutCategory, Val);
			}
			else
				return false;
			break;
		}
		case "equipment":
		{
			allowed = VerifyEquipment(Val);
			if (allowed > 0)
			{
				count = self GetCurrentLoadoutCount(LoadoutCategory, Val);
			}
			else
				return false;
			break;
		}
		case "perk":
		{
			allowed = VerifyPerk(Val);
			if (allowed > 0)
			{
				count = self GetCurrentPerkCount(Val);
			}
			else
				return false;
			break;
		}
		case "attachment":
		{
			allowed = VerifyAttachments(Val);
			if (allowed > 0)
			{
				search_str = GetLoadoutSearchString(LoadoutCategory, Val);
				
				//attachments are on both primary and sidearm so we have to get the counts
				//for each
				count = self GetCurrentLoadoutCount("primary", search_str);
				count += self GetCurrentLoadoutCount("sidearm", search_str);
			}
			else
				return false;
			break;
		}
	}
	
	return count < allowed;
}

GetCurrentLoadoutCount(LoadoutCategory, SearchString)
{
	players = getentarray("player", "classname");
	
	count = 0;

	team = self.pers["team"];
	// Go through all the players
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		if (self == player || team != player.pers["team"])
			continue;
			
		player_loadout = GetGMEntVar(player, "loadout", undefined);
		if (!isDefined(player_loadout))
			continue;
			
		player_loadout_item = "";
		switch(LoadoutCategory)
		{
			case "primary":
			{
				player_loadout_item = player_loadout["primary"];
				break;
			}
			case "sidearm":
			{
				player_loadout_item = player_loadout["secondary"];
				break;
			}
			case "lethal":
			{	
				player_loadout_item = player_loadout["primary_grenades"];
				break;
			}
			case "tactical":
			{
				player_loadout_item = player_loadout["special_grenade"];
				break;
			}
			case "equipment":
			{
				player_loadout_item = player_loadout["equipment_slot"];
				break;
			}						
		}
		
		if (isSubStr(player_loadout_item, SearchString))
			count++;
	}
	
	return count;
}

GetCurrentPerkCount(Perk)
{
	players = getentarray("player", "classname");
	
	count = 0;

	team = self.pers["team"];
	// Go through all the players
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		if (self == player || team != player.pers["team"])
			continue;
			
		player_loadout = GetGMEntVar(player, "loadout", undefined);
		if (!isDefined(player_loadout))
			continue;
		
		perks = player_loadout["specialties"];
		for(j = 0; j < perks.size; j++)
		{
			if (isSubStr(perks, Perk))
			{
				count++;
				break;
			}
		}
	}
	
	return count;
}