#include gm\_Util;
#include gm\Variables;

StartNextOTRound()
{		
	if (IsRoundLimitReached())
	{
		SetupOvertime();
	}
}

IsGameOver()
{	
	if (isDefined(level.scoreRoundBased))
	{	
		roundlimit = GetGMVar("gm_" + level.gametype + "_ot_roundlimit", 0);
		if (level.scoreRoundBased)
		{			
			allies_score = game["roundswon"]["allies"];
			axis_score = game["roundswon"]["axis"];
			
			win_limit = int((roundlimit / 2) + 0.5);
			if (allies_score >= win_limit || axis_score >= win_limit)
			{
				//LogInfo("round based and over winlimit");
				return true;		
			}
		}
		else if (IsRoundLimitReached())
		{
			allies_score = game["teamScores"]["allies"];
			axis_score = game["teamScores"]["axis"];
			
			if (allies_score != axis_score)
			{
				//LogInfo("point based and round limit reached");
				return true;
			}
		}
	}
	else
	{
		LogInfo("level.scoreRoundBased is not defined");
	}
	
	return false;
}

IsRoundLimitReached()
{
	roundlimit = GetGMVar("gm_" + level.gametype + "_ot_roundlimit", 0);
	roundsplayed = GetGMVar("ot_roundsplayed", 0);
	
	return roundsplayed >= roundlimit;		
}

IncRoundsPlayed()
{
	roundsplayed = GetGMVar("ot_roundsplayed", 0) + 1;
	SetGMVar("ot_roundsplayed", roundsplayed);
}

SetupOvertime()
{
	overtime = GetGMVar("overtime", 0);
	overtime++;
	
	SetGMVar("overtime", overtime);
	SetGMVar("ot_roundsplayed", 0);
	NotifyUser("Overtime period " + overtime + " starting");
}

InitDvars()
{
	roundlimit = GetGMVar("gm_" + level.gametype + "_ot_roundlimit", 0);
	win_limit = int((roundlimit / 2) + 0.5);
	SetGMVar("gm_" + level.gametype + "_ot_roundwinlimit", win_limit);
			
	//GMOvertimeRegisterTimeLimitDvar(level.gameType, 15, 0, 1440);
	//GMOvertimeRegisterRoundLimitDvar(level.gameType, 2, 0, 10);
	RegisterRoundWinLimitDvar(level.gameType, 1, 0, 10);
	//GMOvertimeRegisterRoundSwitchDvar(level.gameType, 1, 0, 9);
	//GMOvertimeRegisterNumLivesDvar(level.gameType, 0, 0, 10);
	//GMOvertimeRegisterScoreLimitDvar(level.gameType, 0, 0, 5000);
}

RegisterRoundSwitchDvar( dvarString, defaultValue, minValue, maxValue )
{
	dvarString = ("gm_" + dvarString + "_ot_roundswitch");
	if ( getDvar( dvarString ) == "" )
		setDvar( dvarString, defaultValue );
		
	if ( getDvarInt( dvarString ) > maxValue )
		setDvar( dvarString, maxValue );
	else if ( getDvarInt( dvarString ) < minValue )
		setDvar( dvarString, minValue );
		
	
	level.roundswitchDvar = dvarString;
	level.roundswitchMin = minValue;
	level.roundswitchMax = maxValue;
	level.roundswitch = getDvarInt( level.roundswitchDvar );
	
	SetGMVar(dvarString, level.roundswitch);
}

RegisterRoundLimitDvar( dvarString, defaultValue, minValue, maxValue )
{
	dvarString = ("gm_" + dvarString + "_ot_roundlimit");
	if ( getDvar( dvarString ) == "" )
		setDvar( dvarString, defaultValue );
		
	if ( getDvarInt( dvarString ) > maxValue )
		setDvar( dvarString, maxValue );
	else if ( getDvarInt( dvarString ) < minValue )
		setDvar( dvarString, minValue );
		
	
	level.roundLimitDvar = dvarString;
	level.roundLimitMin = minValue;
	level.roundLimitMax = maxValue;
	level.roundLimit = getDvarInt( level.roundLimitDvar );
	
	SetGMVar(dvarString, level.roundLimit);
}


RegisterRoundWinLimitDvar( dvarString, defaultValue, minValue, maxValue )
{
	dvarString = ("gm_" + dvarString + "_ot_roundwinlimit");
	if ( getDvar( dvarString ) == "" )
		setDvar( dvarString, defaultValue );
		
	if ( getDvarInt( dvarString ) > maxValue )
		setDvar( dvarString, maxValue );
	else if ( getDvarInt( dvarString ) < minValue )
		setDvar( dvarString, minValue );
		
	level.roundWinLimitDvar = dvarString;
	level.roundWinLimitMin = minValue;
	level.roundWinLimitMax = maxValue;
	level.roundWinLimit = getDvarInt( level.roundWinLimitDvar );
	
	SetGMVar(dvarString, level.roundWinLimit);
}

RegisterScoreLimitDvar( dvarString, defaultValue, minValue, maxValue )
{
	dvarString = ("gm_" + dvarString + "_ot_scorelimit");
	if ( getDvar( dvarString ) == "" )
		setDvar( dvarString, defaultValue );
		
	if ( getDvarInt( dvarString ) > maxValue )
		setDvar( dvarString, maxValue );
	else if ( getDvarInt( dvarString ) < minValue )
		setDvar( dvarString, minValue );
		
	level.scoreLimitDvar = dvarString;	
	level.scorelimitMin = minValue;
	level.scorelimitMax = maxValue;
	level.scoreLimit = getDvarInt( level.scoreLimitDvar );
	
	setDvar( "ui_scorelimit", level.scoreLimit );
	
	SetGMVar(dvarString, level.scoreLimit);
}


RegisterTimeLimitDvar( dvarString, defaultValue, minValue, maxValue )
{
	dvarString = ("gm_" + dvarString + "_ot_timelimit");
	if ( getDvar( dvarString ) == "" )
		setDvar( dvarString, defaultValue );
		
	if ( getDvarFloat( dvarString ) > maxValue )
		setDvar( dvarString, maxValue );
	else if ( getDvarFloat( dvarString ) < minValue )
		setDvar( dvarString, minValue );
		
	level.timeLimitDvar = dvarString;	
	level.timelimitMin = minValue;
	level.timelimitMax = maxValue;
	level.timelimit = getDvarFloat( level.timeLimitDvar );
	
	setDvar( "ui_timelimit", level.timelimit );
	
	SetGMVar(dvarString, level.timelimit);
}


RegisterNumLivesDvar( dvarString, defaultValue, minValue, maxValue )
{
	dvarString = ("gm_" + dvarString + "_ot_numlives");
	
	if ( getDvar( dvarString ) == "" )
		setDvar( dvarString, defaultValue );
		
	if ( getDvarInt( dvarString ) > maxValue )
		setDvar( dvarString, maxValue );
	else if ( getDvarInt( dvarString ) < minValue )
		setDvar( dvarString, minValue );
		
	level.numLivesDvar = dvarString;	
	level.numLivesMin = minValue;
	level.numLivesMax = maxValue;
	level.numLives = getDvarInt( level.numLivesDvar );
	//makeDvarServerInfo( level.numLivesDvar, level.numLives );
	
	SetGMVar(dvarString, level.numLives);
}