#include gm\_Util;
//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
InitVariables()
{
	if (!isDefined(game["gm_vars"]))
		game["gm_vars"] = [];
		
	if (!isDefined(game["gm_monitored_dvars"]))
		game["gm_monitored_dvars"] = [];
		
	if (!isDefined(game["gm_dvar_orig_values"]))
		game["gm_dvar_orig_values"] = [];	
}

ReadDvars()
{
	SetGMVar("gm_readyup_enabled", SetDvarDefault("gm_readyup_enabled", false, 0, 1, "int"));
	SetGMVar("gm_readyup_show_enemy_guids", SetDvarDefault("gm_readyup_show_enemy_guids", false, 0, 1, "int"));
	
	if (GetGMVar("gm_readyup_enabled", false) && !IsGMVarDefined("gm_readyup_active"))
		SetGMVar("gm_readyup_active", true);
		
	SetGMVar("gm_players_alive_hud_enabled", SetDvarDefault("gm_players_alive_hud_enabled", false, 0, 1, "int"));
	
	SetGMVar("gm_version", "GoneMOD Alpha 0.1");
	SetGMVar("gm_main_hud_enabled", SetDvarDefault("gm_main_hud_enabled", false, 0, 1, "int"));
	
	//knife
	SetGMVar("gm_knife_autoaim_enabled", SetDvarDefault("gm_knife_autoaim_enabled", true, 0, 1, "int"));
	SetGMVar("gm_knife_autoaim_range", SetDvarDefault("gm_knife_autoaim_range", 128, 0, 10000, "int"));	
	SetGMVar("gm_knife_use_hitbox_modifiers", SetDvarDefault("gm_knife_use_hitbox_modifiers", false, 0, 1, "int"));
	
	//ambient effects
	SetGMVar("gm_fx_ambient_sound_enabled", SetDvarDefault("gm_fx_ambient_sound_enabled", true, 0, 1, "int"));
	SetGMVar("gm_fx_volumetric_fog_enabled", SetDvarDefault("gm_fx_volumetric_fog_enabled", true, 0, 1, "int"));
	SetGMVar("gm_fx_visual_enabled", SetDvarDefault("gm_fx_visual_enabled", true, 0, 1, "int"));
	
	//map specific
	SetGMVar("gm_map_launch_rocket_enabled", SetDvarDefault("gm_map_launch_rocket_enabled", true, 0, 1, "int"));
	SetGMVar("gm_map_wmd_train_enabled", SetDvarDefault("gm_map_wmd_train_enabled", true, 0, 1, "int"));
	SetGMVar("gm_map_radiation_digger_enabled", SetDvarDefault("gm_map_radiation_digger_enabled", true, 0, 1, "int"));
		
	//hit blips
	SetGMVar("gm_hitblips_enabled", SetDvarDefault("gm_hitblips_enabled", true, 0, 1, "int"));
	SetGMVar("gm_hitblips_lethal_enabled", SetDvarDefault("gm_hitblips_lethal_enabled", true, 0, 1, "int"));
	SetGMVar("gm_hitblips_tactical_enabled", SetDvarDefault("gm_hitblips_tactical_enabled", true, 0, 1, "int"));
	SetGMVar("gm_hitblips_penetration_enabled", SetDvarDefault("gm_hitblips_penetration_enabled", true, 0, 1, "int"));
	
	//hitbox modifiers
	SetGMVar("gm_hitbox_damage_mod_enabled", SetDvarDefault("gm_hitbox_damage_mod_enabled", false, 0, 1, "int"));
	SetGMVar("gm_hitbox_damage_mod_helmet", SetDvarDefault("gm_hitbox_damage_mod_helmet", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_head", SetDvarDefault("gm_hitbox_damage_mod_head", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_neck", SetDvarDefault("gm_hitbox_damage_mod_neck", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_torso_upper", SetDvarDefault("gm_hitbox_damage_mod_torso_upper", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_right_arm_upper", SetDvarDefault("gm_hitbox_damage_mod_right_arm_upper", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_left_arm_upper", SetDvarDefault("gm_hitbox_damage_mod_left_arm_upper", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_right_arm_lower", SetDvarDefault("gm_hitbox_damage_mod_right_arm_lower", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_left_arm_lower", SetDvarDefault("gm_hitbox_damage_mod_left_arm_lower", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_right_hand", SetDvarDefault("gm_hitbox_damage_mod_right_hand", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_left_hand", SetDvarDefault("gm_hitbox_damage_mod_left_hand", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_gun", SetDvarDefault("gm_hitbox_damage_mod_gun", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_torso_lower", SetDvarDefault("gm_hitbox_damage_mod_torso_lower", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_right_leg_upper", SetDvarDefault("gm_hitbox_damage_mod_right_leg_upper", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_left_leg_upper", SetDvarDefault("gm_hitbox_damage_mod_left_leg_upper", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_right_leg_lower", SetDvarDefault("gm_hitbox_damage_mod_right_leg_lower", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_left_leg_lower", SetDvarDefault("gm_hitbox_damage_mod_left_leg_lower", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_right_foot", SetDvarDefault("gm_hitbox_damage_mod_right_foot", 1.0, 0.0, 100.0, "float"));
	SetGMVar("gm_hitbox_damage_mod_left_foot", SetDvarDefault("gm_hitbox_damage_mod_left_foot", 1.0, 0.0, 100.0, "float"));
	
	//attachments
	SetGMVar("gm_attachments_allow_silencer", SetDvarDefault("gm_attachments_allow_silencer", 99, 0, 99, "int"));
	SetGMVar("gm_attachments_allow_grip", SetDvarDefault("gm_attachments_allow_grip", 99, 0, 99, "int"));
	SetGMVar("gm_attachments_allow_extended_mags", SetDvarDefault("gm_attachments_allow_extended_mags", 99, 0, 99, "int"));
	SetGMVar("gm_attachments_allow_reddot", SetDvarDefault("gm_attachments_allow_reddot", 99, 0, 99, "int"));
	SetGMVar("gm_attachments_allow_reflex", SetDvarDefault("gm_attachments_allow_reflex", 99, 0, 99, "int"));
	SetGMVar("gm_attachments_allow_dual_mags", SetDvarDefault("gm_attachments_allow_dual_mags", 99, 0, 99, "int"));
	SetGMVar("gm_attachments_allow_acog", SetDvarDefault("gm_attachments_allow_acog", 99, 0, 99, "int"));	
	SetGMVar("gm_attachments_allow_masterkey", SetDvarDefault("gm_attachments_allow_masterkey", 99, 0, 99, "int"));	
	SetGMVar("gm_attachments_allow_flamethrower", SetDvarDefault("gm_attachments_allow_flamethrower", 99, 0, 99, "int"));	
	SetGMVar("gm_attachments_allow_infared", SetDvarDefault("gm_attachments_allow_infared", 99, 0, 99, "int"));	
	SetGMVar("gm_attachments_allow_gren_launcher", SetDvarDefault("gm_attachments_allow_gren_launcher", 99, 0, 99, "int"));	
	SetGMVar("gm_attachments_allow_var_zoom", SetDvarDefault("gm_attachments_allow_var_zoom", 99, 0, 99, "int"));	
	SetGMVar("gm_attachments_allow_dual_wield", SetDvarDefault("gm_attachments_allow_dual_wield", 99, 0, 99, "int"));	
	SetGMVar("gm_attachments_allow_rapid_fire", SetDvarDefault("gm_attachments_allow_rapid_fire", 99, 0, 99, "int"));
	
	//pistol attachments
	SetGMVar("gm_attachments_allow_snub_nose", SetDvarDefault("gm_attachments_allow_snub_nose", 99, 0, 99, "int"));
	SetGMVar("gm_attachments_allow_speed_reloader", SetDvarDefault("gm_attachments_allow_speed_reloader", 99, 0, 99, "int"));
	SetGMVar("gm_attachments_allow_full_auto_upg", SetDvarDefault("gm_attachments_allow_full_auto_upg", 99, 0, 99, "int"));
	SetGMVar("gm_attachments_allow_upg_iron_sights", SetDvarDefault("gm_attachments_allow_upg_iron_sights", 99, 0, 99, "int"));
	
	//lethal
	SetGMVar("gm_lethal_allow_frag", SetDvarDefault("gm_lethal_allow_frag", 99, 0, 99, "int"));
	SetGMVar("gm_lethal_allow_semtex", SetDvarDefault("gm_lethal_allow_semtex", 99, 0, 99, "int"));
	SetGMVar("gm_lethal_allow_tomahawk", SetDvarDefault("gm_lethal_allow_tomahawk", 99, 0, 99, "int"));
	//tactical
	SetGMVar("gm_tactical_allow_willy_pete", SetDvarDefault("gm_tactical_allow_willy_pete", 99, 0, 99, "int"));
	SetGMVar("gm_tactical_allow_nova_gas", SetDvarDefault("gm_tactical_allow_nova_gas", 99, 0, 99, "int"));
	SetGMVar("gm_tactical_allow_flashbang", SetDvarDefault("gm_tactical_allow_flashbang", 99, 0, 99, "int"));
	SetGMVar("gm_tactical_allow_concussion", SetDvarDefault("gm_tactical_allow_concussion", 99, 0, 99, "int"));
	SetGMVar("gm_tactical_allow_decoy", SetDvarDefault("gm_tactical_allow_decoy", 99, 0, 99, "int"));
	//equipment
	SetGMVar("gm_equipment_allow_camera_spike", SetDvarDefault("gm_equipment_allow_camera_spike", 99, 0, 99, "int"));
	SetGMVar("gm_equipment_allow_c4", SetDvarDefault("gm_equipment_allow_c4", 99, 0, 99, "int"));
	SetGMVar("gm_equipment_allow_tac_insert", SetDvarDefault("gm_equipment_allow_tac_insert",99, 0, 99, "int"));
	SetGMVar("gm_equipment_allow_jammer", SetDvarDefault("gm_equipment_allow_jammer", 99, 0, 99, "int"));
	SetGMVar("gm_equipment_allow_motion_sensor", SetDvarDefault("gm_equipment_allow_motion_sensor", 99, 0, 99, "int"));
	SetGMVar("gm_equipment_allow_claymore", SetDvarDefault("gm_equipment_allow_claymore", 99, 0, 99, "int"));
	//weapons
	//AR
	SetGMVar("gm_assault_allow_ak47", SetDvarDefault("gm_assault_allow_ak47", 99, 0, 99, "int"));
	SetGMVar("gm_assault_allow_aug", SetDvarDefault("gm_assault_allow_aug", 99, 0, 99, "int"));
	SetGMVar("gm_assault_allow_commando", SetDvarDefault("gm_assault_allow_commando", 99, 0, 99, "int"));
	SetGMVar("gm_assault_allow_enfield", SetDvarDefault("gm_assault_allow_enfield", 99, 0, 99, "int"));
	SetGMVar("gm_assault_allow_famas", SetDvarDefault("gm_assault_allow_famas", 99, 0, 99, "int"));
	SetGMVar("gm_assault_allow_fnfal", SetDvarDefault("gm_assault_allow_fnfal", 99, 0, 99, "int"));
	SetGMVar("gm_assault_allow_galil", SetDvarDefault("gm_assault_allow_galil", 99, 0, 99, "int"));
	SetGMVar("gm_assault_allow_m14", SetDvarDefault("gm_assault_allow_m14", 99, 0, 99, "int"));
	SetGMVar("gm_assault_allow_m16", SetDvarDefault("gm_assault_allow_m16", 99, 0, 99, "int"));
	SetGMVar("gm_assault_allow_g11", SetDvarDefault("gm_assault_allow_g11", 99, 0, 99, "int"));
	
	//Shotgun
	SetGMVar("gm_shotgun_allow_olympia", SetDvarDefault("gm_shotgun_allow_olympia", 99, 0, 99, "int"));
	SetGMVar("gm_shotgun_allow_spas", SetDvarDefault("gm_shotgun_allow_spas", 99, 0, 99, "int"));
	SetGMVar("gm_shotgun_allow_stakeout", SetDvarDefault("gm_shotgun_allow_stakeout", 99, 0, 99, "int"));
	SetGMVar("gm_shotgun_allow_hs10", SetDvarDefault("gm_shotgun_allow_hs10", 99, 0, 99, "int"));
	
	//Lmg
	SetGMVar("gm_lmg_allow_hk21", SetDvarDefault("gm_lmg_allow_hk21", 99, 0, 99, "int"));
	SetGMVar("gm_lmg_allow_m60", SetDvarDefault("gm_lmg_allow_m60", 99, 0, 99, "int"));
	SetGMVar("gm_lmg_allow_rpk", SetDvarDefault("gm_lmg_allow_rpk", 99, 0, 99, "int"));
	SetGMVar("gm_lmg_allow_stoner63", SetDvarDefault("gm_lmg_allow_stoner63", 99, 0, 99, "int"));
	
	//Smg
	SetGMVar("gm_smg_allow_ak74u", SetDvarDefault("gm_smg_allow_ak74u", 99, 0, 99, "int"));
	SetGMVar("gm_smg_allow_kiparis", SetDvarDefault("gm_smg_allow_kiparis", 99, 0, 99, "int"));
	SetGMVar("gm_smg_allow_mac11", SetDvarDefault("gm_smg_allow_mac11", 99, 0, 99, "int"));
	SetGMVar("gm_smg_allow_mp5k", SetDvarDefault("gm_smg_allow_mp5k", 99, 0, 99, "int"));
	SetGMVar("gm_smg_allow_mpl", SetDvarDefault("gm_smg_allow_mpl", 99, 0, 99, "int"));
	SetGMVar("gm_smg_allow_skorpion", SetDvarDefault("gm_smg_allow_skorpion", 99, 0, 99, "int"));
	SetGMVar("gm_smg_allow_spectre", SetDvarDefault("gm_smg_allow_spectre", 99, 0, 99, "int"));
	SetGMVar("gm_smg_allow_uzi", SetDvarDefault("gm_smg_allow_uzi", 99, 0, 99, "int"));
	SetGMVar("gm_smg_allow_pm63", SetDvarDefault("gm_smg_allow_pm63", 99, 0, 99, "int"));
	
	//Sniper
	SetGMVar("gm_sniper_allow_dragunov", SetDvarDefault("gm_sniper_allow_dragunov", 99, 0, 99, "int"));
	SetGMVar("gm_sniper_allow_l96a1", SetDvarDefault("gm_sniper_allow_l96a1", 99, 0, 99, "int"));
	SetGMVar("gm_sniper_allow_wa2000", SetDvarDefault("gm_sniper_allow_wa2000", 99, 0, 99, "int"));
	SetGMVar("gm_sniper_allow_psg1", SetDvarDefault("gm_sniper_allow_psg1", 99, 0, 99, "int"));
	
	//secondary
	//pistols
	SetGMVar("gm_pistol_allow_asp", SetDvarDefault("gm_pistol_allow_asp", 99, 0, 99, "int"));
	SetGMVar("gm_pistol_allow_cz75", SetDvarDefault("gm_pistol_allow_cz75", 99, 0, 99, "int"));
	SetGMVar("gm_pistol_allow_m1911", SetDvarDefault("gm_pistol_allow_m1911", 99, 0, 99, "int"));
	SetGMVar("gm_pistol_allow_python", SetDvarDefault("gm_pistol_allow_python", 99, 0, 99, "int"));
	SetGMVar("gm_pistol_allow_makarov", SetDvarDefault("gm_pistol_allow_makarov", 99, 0, 99, "int"));
	
	//launchers
	SetGMVar("gm_launcher_allow_china_lake", SetDvarDefault("gm_launcher_allow_china_lake", 99, 0, 99, "int"));
	SetGMVar("gm_launcher_allow_rpg", SetDvarDefault("gm_launcher_allow_rpg", 99, 0, 99, "int"));
	SetGMVar("gm_launcher_allow_strela", SetDvarDefault("gm_launcher_allow_strela", 99, 0, 99, "int"));
	SetGMVar("gm_launcher_allow_m72", SetDvarDefault("gm_launcher_allow_m72", 99, 0, 99, "int"));
		
	//special
	SetGMVar("gm_special_allow_ballistic_knife", SetDvarDefault("gm_special_allow_ballistic_knife", 99, 0, 99, "int"));
	SetGMVar("gm_special_allow_crossbow", SetDvarDefault("gm_special_allow_crossbow", 99, 0, 99, "int"));
	
	//perks
	SetGMVar("gm_specialty_allow_armorpiercing", SetDvarDefault("gm_specialty_allow_armorpiercing", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_armorvest", SetDvarDefault("gm_specialty_allow_armorvest", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_bulletaccuracy", SetDvarDefault("gm_specialty_allow_bulletaccuracy", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_bulletdamage", SetDvarDefault("gm_specialty_allow_bulletdamage", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_bulletflinch", SetDvarDefault("gm_specialty_allow_bulletflinch", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_bulletpenetration", SetDvarDefault("gm_specialty_allow_bulletpenetration", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_copycat", SetDvarDefault("gm_specialty_allow_copycat", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_delayexplosive", SetDvarDefault("gm_specialty_allow_delayexplosive", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_detectexplosive", SetDvarDefault("gm_specialty_allow_detectexplosive", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_disarmexplosive", SetDvarDefault("gm_specialty_allow_disarmexplosive", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_explosivedamage", SetDvarDefault("gm_specialty_allow_explosivedamage", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_extraammo", SetDvarDefault("gm_specialty_allow_extraammo", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_extramoney", SetDvarDefault("gm_specialty_allow_extramoney", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_fallheight", SetDvarDefault("gm_specialty_allow_fallheight", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_fastads", SetDvarDefault("gm_specialty_allow_fastads", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_fastinteract", SetDvarDefault("gm_specialty_allow_fastinteract", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_fastmantle", SetDvarDefault("gm_specialty_allow_fastmantle", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_fastmeleerecovery", SetDvarDefault("gm_specialty_allow_fastmeleerecovery", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_fastreload", SetDvarDefault("gm_specialty_allow_fastreload", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_fastweaponswitch", SetDvarDefault("gm_specialty_allow_fastweaponswitch", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_finalstand", SetDvarDefault("gm_specialty_allow_finalstand", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_fireproof", SetDvarDefault("gm_specialty_allow_fireproof", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_flakjacket", SetDvarDefault("gm_specialty_allow_flakjacket", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_gambler", SetDvarDefault("gm_specialty_allow_gambler", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_gas_mask", SetDvarDefault("gm_specialty_allow_gas_mask", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_gpsjammer", SetDvarDefault("gm_specialty_allow_gpsjammer", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_grenadepulldeath", SetDvarDefault("gm_specialty_allow_grenadepulldeath", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_healthregen", SetDvarDefault("gm_specialty_allow_healthregen", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_holdbreath", SetDvarDefault("gm_specialty_allow_holdbreath", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_killstreak", SetDvarDefault("gm_specialty_allow_killstreak", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_longersprint", SetDvarDefault("gm_specialty_allow_longersprint", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_loudenemies", SetDvarDefault("gm_specialty_allow_loudenemies", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_movefaster", SetDvarDefault("gm_specialty_allow_movefaster", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_nomotionsensor", SetDvarDefault("gm_specialty_allow_nomotionsensor", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_noname", SetDvarDefault("gm_specialty_allow_noname", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_nottargetedbyai", SetDvarDefault("gm_specialty_allow_nottargetedbyai", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_pin_back", SetDvarDefault("gm_specialty_allow_pin_back", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_pistoldeath", SetDvarDefault("gm_specialty_allow_pistoldeath", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_quieter", SetDvarDefault("gm_specialty_allow_quieter", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_reconnaissance", SetDvarDefault("gm_specialty_allow_reconnaissance", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_rof", SetDvarDefault("gm_specialty_allow_rof", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_scavenger", SetDvarDefault("gm_specialty_allow_scavenger", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_shades", SetDvarDefault("gm_specialty_allow_shades", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_shellshock", SetDvarDefault("gm_specialty_allow_shellshock", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_showenemyequipment", SetDvarDefault("gm_specialty_allow_showenemyequipment", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_showonradar", SetDvarDefault("gm_specialty_allow_showonradar", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_sprintrecovery", SetDvarDefault("gm_specialty_allow_sprintrecovery", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_stunprotection", SetDvarDefault("gm_specialty_allow_stunprotection", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_twoattach", SetDvarDefault("gm_specialty_allow_twoattach", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_twogrenades", SetDvarDefault("gm_specialty_allow_twogrenades", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_twoprimaries", SetDvarDefault("gm_specialty_allow_twoprimaries", 99, 0, 99, "int"));
	SetGMVar("gm_specialty_allow_unlimitedsprint", SetDvarDefault("gm_specialty_allow_unlimitedsprint", 99, 0, 99, "int"));
		
	//concussion/flash
	SetGMVar("gm_concussion_radius", SetDvarDefault("gm_concussion_radius", 512, 0, 1024, "int"));
	
	if (getdvar("gm_concussion_max_duration") != "")
		SetGMVar("gm_concussion_max_duration", SetDvarDefault("gm_concussion_max_duration", 0, 0, 10, "int"));
		
	if (getdvar("gm_flash_max_duration") != "")
		SetGMVar("gm_flash_max_duration", SetDvarDefault("gm_flash_max_duration", 0, 0, 10, "int"));
		
	SetGMVar("gm_concussion_sound_enabled", SetDvarDefault("gm_concussion_sound_enabled", true, 0, 1, "int"));
	SetGMVar("gm_flash_sound_enabled", SetDvarDefault("gm_flash_sound_enabled", true, 0, 1, "int"));

	//headbob
	SetGMVar("gm_headbob_enabled", SetDvarDefault("gm_headbob_enabled", true, 0, 1, "int"));
	SetGMVar("gm_fall_damage_min_height", SetDvarDefault("gm_fall_damage_min_height", 256, 0, 99999, "int"));
	SetGMVar("gm_fall_damage_max_height", SetDvarDefault("gm_fall_damage_max_height", 480, 0, 99999, "int"));
	SetGMVar("gm_allow_red_enemy_crosshairs", SetDvarDefault("gm_allow_red_enemy_crosshairs", true, 0, 1, "int"));
	
	//gametype specific
	//CTF
	SetGMVar("gm_ctf_allow_flag_drop", SetDvarDefault("gm_ctf_allow_flag_drop", false, 0, 1, "int"));
	SetGMVar("gm_ctf_round_based_scoring", SetDvarDefault("gm_ctf_round_based_scoring", true, 0, 1, "int"));
	SetGMVar("gm_ctf_ot_suddendeath", SetDvarDefault("gm_ctf_ot_suddendeath", 1, 0, 9999, "int"));
	
	SetGMVar("gm_tdm_round_based_scoring", SetDvarDefault("gm_tdm_round_based_scoring", true, 0, 1, "int"));
	SetGMVar("gm_dom_round_based_scoring", SetDvarDefault("gm_dom_round_based_scoring", true, 0, 1, "int"));
	SetGMVar("gm_koth_round_based_scoring", SetDvarDefault("gm_koth_round_based_scoring", true, 0, 1, "int"));
	
	if (getdvarint("scr_sd_multibomb") == 0)
		SetGMVar("gm_sd_allow_bomb_drop", SetDvarDefault("gm_sd_allow_bomb_drop", false, 0, 1, "int"));
	else
		SetGMVar("gm_sd_allow_bomb_drop", false);
		
	SetGMVar("gm_sd_hide_briefcase", SetDvarDefault("gm_sd_hide_briefcase", false, 0, 1, "int"));
	SetGMVar("gm_sd_sounds_plant_enabled", SetDvarDefault("gm_sd_sounds_plant_enabled", false, 0, 1, "int"));
	SetGMVar("gm_sd_sounds_defuse_enabled", SetDvarDefault("gm_sd_sounds_defuse_enabled", false, 0, 1, "int"));
	SetGMVar("gm_sd_sounds_plant_looptime", SetDvarDefault("gm_sd_sounds_plant_looptime", 1.5, 0, 100.0, "float"));
	SetGMVar("gm_sd_sounds_defuse_looptime", SetDvarDefault("gm_sd_sounds_defuse_looptime", 1.5, 0, 100.0, "float"));
	SetGMVar("gm_sd_strat_time", SetDvarDefault("gm_sd_strat_time", 0, 0, 99, "int"));
		
	SetGMVar("gm_dem_hide_briefcase", SetDvarDefault("gm_dem_hide_briefcase", false, 0, 1, "int"));
	SetGMVar("gm_dem_sounds_plant_enabled", SetDvarDefault("gm_dem_sounds_plant_enabled", false, 0, 1, "int"));
	SetGMVar("gm_dem_sounds_defuse_enabled", SetDvarDefault("gm_dem_sounds_defuse_enabled", false, 0, 1, "int"));
	SetGMVar("gm_dem_sounds_plant_looptime", SetDvarDefault("gm_dem_sounds_plant_looptime", 1.5, 0, 100.0, "float"));
	SetGMVar("gm_dem_sounds_defuse_looptime", SetDvarDefault("gm_dem_sounds_defuse_looptime", 1.5, 0, 100.0, "float"));

	SetGMVar("gm_sab_allow_bomb_drop", SetDvarDefault("gm_sab_allow_bomb_drop", false, 0, 1, "int"));
	SetGMVar("gm_sab_hide_briefcase", SetDvarDefault("gm_sab_hide_briefcase", false, 0, 1, "int"));
	SetGMVar("gm_sab_sounds_plant_enabled", SetDvarDefault("gm_sab_sounds_plant_enabled", false, 0, 1, "int"));
	SetGMVar("gm_sab_sounds_defuse_enabled", SetDvarDefault("gm_sab_sounds_defuse_enabled", false, 0, 1, "int"));
	SetGMVar("gm_sab_sounds_plant_looptime", SetDvarDefault("gm_sab_sounds_plant_looptime", 1.5, 0, 100.0, "float"));	
	SetGMVar("gm_sab_sounds_defuse_looptime", SetDvarDefault("gm_sab_sounds_defuse_looptime", 1.5, 0, 100.0, "float"));	
	SetGMVar("gm_sab_show_2D_bombsites", SetDvarDefault("gm_sab_show_2D_bombsites", true, 0, 1, "int"));
	SetGMVar("gm_sab_show_3D_bombsites", SetDvarDefault("gm_sab_show_3D_bombsites", true, 0, 1, "int"));
	SetGMVar("gm_sab_comp_mode_enabled", SetDvarDefault("gm_sab_comp_mode_enabled", false, 0, 1, "int"));
	SetGMVar("gm_sab_comp_mode_spawnincrease", SetDvarDefault("gm_sab_comp_mode_spawnincrease", 5, 0.5, 9999.0, "float"));	
	SetGMVar("gm_sab_comp_mode_maxspawntime", SetDvarDefault("gm_sab_comp_mode_maxspawntime", 60, 0, 9999.0, "float"));	
	SetGMVar("gm_sab_comp_mode_incrementtime", SetDvarDefault("gm_sab_comp_mode_incrementtime", 60, 5, 9999.0, "float"));	
	SetGMVar("gm_sab_enemy_bomb_carrier_visible", SetDvarDefault("gm_sab_enemy_bomb_carrier_visible", true, 0, 1, "int"));
		
	SetGMVar("gm_class_limits_assault", SetDvarDefault("gm_class_limits_assault", -1, -1, 99, "int"));
	SetGMVar("gm_class_limits_smg", SetDvarDefault("gm_class_limits_smg", -1, -1, 99, "int"));
	SetGMVar("gm_class_limits_lmg", SetDvarDefault("gm_class_limits_lmg", -1, -1, 99, "int"));
	SetGMVar("gm_class_limits_shotgun", SetDvarDefault("gm_class_limits_shotgun", -1, -1, 99, "int"));
	SetGMVar("gm_class_limits_sniper", SetDvarDefault("gm_class_limits_sniper", -1, -1, 99, "int"));
	
	SetGMVar("gm_equipment_starting_count", SetDvarDefault("gm_equipment_starting_count", -1, -1, 2, "int"));
	SetGMVar("gm_tactical_starting_count", SetDvarDefault("gm_tactical_starting_count", -1, -1, 2, "int"));
	SetGMVar("gm_lethal_starting_count", SetDvarDefault("gm_lethal_starting_count", -1, -1, 2, "int"));	
	SetGMVar("gm_primary_ammo_starting_count", SetDvarDefault("gm_primary_ammo_starting_count", -1, -1, 9999, "int"));
	SetGMVar("gm_sidearm_ammo_starting_count", SetDvarDefault("gm_sidearm_ammo_starting_count", -1, -1, 9999, "int"));
	
	SetGMVar("gm_popups_enabled", SetDvarDefault("gm_popups_enabled", true, 0, 1, "int"));
	SetGMVar("gm_battlechatter_enabled", SetDvarDefault("gm_battlechatter_enabled", true, 0, 1, "int"));
	SetGMVar("gm_silent_ads", SetDvarDefault("gm_silent_ads", false, 0, 1, "int"));
	
	SetGMVar("gm_restricted_weapon_drops_enabled", SetDvarDefault("gm_restricted_weapon_drops_enabled", false, 0, 1, "int"));	
	SetGMVar("gm_tactical_drops_enabled", SetDvarDefault("gm_tactical_drops_enabled", true, 0, 1, "int"));
	SetGMVar("gm_lethal_drops_enabled", SetDvarDefault("gm_lethal_drops_enabled", true, 0, 1, "int"));
		
	SetGMVar("gm_timeout_count", SetDvarDefault("gm_timeout_count", 0, 0, 99, "int"));
	SetGMVar("gm_timeout_duration", SetDvarDefault("gm_timeout_duration", 60, 0, 9999, "int"));
	
	SetGMVar("gm_overtime_enabled", SetDvarDefault("gm_overtime_enabled", false, 0, 1, "int"));
	
	SetGMVar("gm_sv_cheats_notifier", SetDvarDefault("gm_sv_cheats_notifier", false, 0, 1, "int"));
	SetGMVar("gm_event_notifications", SetDvarDefault("gm_event_notifications", false, 0, 1, "int"));
		
	SetGMVar("gm_dvars_read", true);
}

//credit to bullet-worm / PAM4.02
SetDvarDefault( dvarName, setVal, minVal, maxVal, type )
{
	// no value set
	if ( getDvar( dvarName ) != "" )
	{
		if ( isString( setVal ) )
			setVal = getDvar( dvarName );
		else
		{
			if (isDefined(type) && type == "float")
				setVal = getDvarFloat( dvarName );
			else
				setVal = getDvarInt( dvarName );
		}
	}
		
	if ( isDefined( minVal ) && !isString( setVal ) )
		setVal = max( setVal, minVal );

	if ( isDefined( maxVal ) && !isString( setVal ) )
		setVal = min( setVal, maxVal );

	setDvar( dvarName, setVal );
	return setVal;
}
//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
GetGMVar(Name, Default)
{
	val = game["gm_vars"][Name];
	if (!isDefined(val))
	{
		SetGMVar(Name, Default);
		val = Default;
	}
	
	return val;
}

SetGMVar(Name, Value)
{
	game["gm_vars"][Name] = Value;
}

IsGMVarDefined(Name)
{
	return isDefined(game["gm_vars"][Name]);
}
//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
GetGMEntVar(Entity, VarName, Default)
{
	if (!isDefined(Entity.GMEntVars))
	{
		SetGMEntVar(Entity, VarName, Default);
		return Default;
	}
	
	val = Entity.GMEntVars[VarName];
	if (!isDefined(val))
	{
		SetGMEntVar(Entity, VarName, Default);
		val = Default;
	}
	
	return val;
}

SetGMEntVar(Entity, VarName, Value)
{
	if (!isDefined(Entity.GMEntVars))
		Entity.GMEntVars = [];
		
	Entity.GMEntVars[VarName] = Value;
}

IsGMEntVarDefined(Entity, VarName)
{
	return isDefined(Entity.GMEntVars) && isDefined(Entity.GMEntVars[VarName]);
}
//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
AddDvarMonitor(Dvar, Callback)
{
	game["gm_monitored_dvars"][Dvar] = Callback;
	
	var = getdvar(Dvar);
	if (!isDefined(var))
		LogWarning("Trying to monitor undefined dvar: " + Dvar);
	
	game["gm_dvar_orig_values"][Dvar] = var;
}

RemoveDvarMonitor(Dvar)
{
	game["gm_monitored_dvars"][Dvar] = undefined;
	game["gm_dvar_orig_values"][Dvar] = undefined;
}
//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
MonitorDvars()
{
	dvar_array = GetArrayKeys(game["gm_monitored_dvars"]);
	
	//find original values for all the dvars we are monitoring
	for (i = 0; i < dvar_array.size; i++)
	{
		var_name = dvar_array[i];
		orig_val = getdvar(var_name);
		
		game["gm_dvar_orig_values"][var_name] = orig_val;		
	}

	while (true)
	{
		wait 1.0;

		dvar_array = GetArrayKeys(game["gm_monitored_dvars"]);
	
		//find new values for all the dvars we are monitoring
		for (i = 0; i < dvar_array.size; i++)
		{
			var_name = dvar_array[i];
			new_val = getdvar(var_name);
			orig_val = game["gm_dvar_orig_values"][var_name];
			
			if (new_val != orig_val)
			{
				//check if new val is valid;
				if(IsDvarValid(var_name, new_val))
				{
					callback = game["gm_monitored_dvars"][var_name];
					if (isDefined(callback))
					{
						restart_monitoring = [[callback]](var_name, orig_val, new_val);
						if (restart_monitoring == true)
							return;
					}
					else
						LogError("Callback for " + var_name + " is undefined");
				}
				else
				{
					// not valid
					LogError("Invalid value for " + var_name);
					setdvar(var_name, orig_val);
				}				
			}
			wait 0.01;
		}
	}
}

IsDvarValid(Dvar, Value)
{
	return true;
}
//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------
SetupClientDvarMonitoring()
{
	restrictions = gm\Configs\DvarRestrictions::Load();
	SetGMVar("gm_client_dvar_restrictions", restrictions);	
}

MonitorClientDvars()
{
	//the idea here is for the server to set a client dvar letting it know what to monitor
	possible_dvars = [];
	possible_dvars[0] = "cl_maxpackets";
	
	setdvar("gm_monitoring", true);
	
	LogInfo("monitoring client dvars!");
	
	//wait until all the restrictions are set
	while (true)
	{
		if (getdvar("gm_dvar_violation_mode") != "")
			break;
		wait 1;
	}
	
	violation_mode = getdvar("gm_dvar_violation_mode");
	
	//if undefined doestn work use ""
	setdvar("gm_dvar_violation_mode", "");
	
	monitored_dvars = [];
	
	//determine what dvars need to be monitored
	for(i = 0; i < possible_dvars.size; i++)
	{
		possible_dvar_restriction = getdvar("gm_dvarmon_" + possible_dvars[i]);
		setdvar("gm_dvarmon_" + possible_dvars[i], "");
		
		if(possible_dvar_restriction == "") continue;
		
		restriction_struct = ParseDvarRestrictionString(possible_dvar_restriction);
		
		if (isDefined(restriction_struct))
		{
			monitored_dvars[possible_dvars[i]] = restriction_struct;		
		}
		else
		{
			//log error
		}
		wait .0001;
	}
	
	while(true)
	{
		LogInfo("monitoring loop");
		monitored_keys = GetArrayKeys(monitored_dvars);
		
		for (j = 0; j < monitored_keys.size; j++)
		{
			monitored_dvar = monitored_keys[j];
			LogInfo(monitored_dvar);
			
			r_struct = monitored_dvars[monitored_dvar];
			
			if (isDefined(r_struct) && isDefined(r_struct.type))
			{
				switch(r_struct.type)
				{
					case "in1":
						LogInfo("in1");
						setdvar(monitored_dvar, r_struct.val);
						break;
					case "in2":
						val = getdvarint(monitored_dvar);
						LogInfo("in2: val = " + val);
						
						if (val < r_struct.lbound)
						{
							setdvar(monitored_dvar, r_struct.lbound);
							LogInfo("Val lower than lbound");
						}
					
						if (val > r_struct.ubound)
						{	
							setdvar(monitored_dvar, r_struct.ubound);
							LogInfo("Val higher than ubound");
						}
						break;
					case "out1":
						LogInfo("out1");
						val = getdvarint(monitored_dvar);
						if (val == r_struct.val)
							ProcessViolation(monitored_dvar, val, r_struct);
						break;
					case "out2":
						LogInfo("out2");
						val = getdvarint(monitored_dvar);
						
						if (val > r_struct.lbound)
							setdvar(monitored_dvar, r_struct.lbound);
					
						if (val < r_struct.ubound)
							setdvar(monitored_dvar, r_struct.ubound);
						
						break;
					case "include":
						LogInfo("include");	
						val = getdvar(monitored_dvar);
						for(k = 0; k < r_struct.includes.size; k++)
						{
							if (!IsSubStr(val, r_struct.includes[k]))
								ProcessViolation(monitored_dvar, val, r_struct);
						}
						break;
					case "exclude":
						LogInfo("exclude");
						val = getdvar(monitored_dvar);
						for(k = 0; k < r_struct.excludes.size; k++)
						{
							if (IsSubStr(val, r_struct.excludes[k]))
								ProcessViolation(monitored_dvar, val, r_struct);
						}
						break;
				}				
			}
			
			wait .01;
		}
		
		//make time random
		wait 10;		
	}
}

ParseDvarRestrictionString(Restriction)
{
	LogInfo("Restriction String = " + Restriction);
	toks = strtok(Restriction, " ");
	size = toks.size;
	LogInfo("Tok Size = " + size);
	
	if (size < 1) return undefined;
	
	type = toks[0];
	restriction_struct = spawnstruct();
	restriction_struct.type = ""; //IN OUT INCLUDE EXCLUDE
	
	LogInfo("Type = " + type);
	switch(tolower(type))
	{
		case "in":
			if (size == 2)
			{
				restriction_struct.type = "in1";
				restriction_struct.val = int(toks[1]);
			}
			else if (size == 3)
			{
				restriction_struct.type = "in2";
				restriction_struct.lbound = int(toks[1]);
				restriction_struct.ubound = int(toks[2]);
			}
			else
			{
				return undefined;
			}
				
			break;
		case "out":
			if (size == 2)
			{
				restriction_struct.type = "out1";
				restriction_struct.val = int(toks[1]);
			}
			else if (size == 3)
			{
				restriction_struct.type = "out2";
				restriction_struct.lbound = int(toks[1]);
				restriction_struct.ubound = int(toks[2]);
			}
			else
			{
				return undefined;
			}
				
			break;
		case "include":
			if (size > 1)
			{
				restriction_struct.type = "include";
				restriction_struct.includes = [];
				for(j = 1; j < size + 1; j++)
					restriction_struct.includes[j-1] = toks[j];
					
			}
			else
			{
				return undefined;
			}
			
			break;
		case "exclude":
			if (size > 1)
			{
				restriction_struct.type = "exclude";
				restriction_struct.excludes = [];
				for(j = 1; j < size + 1; j++)
					restriction_struct.excludes[j-1] = toks[j];
			}
			else
			{
				return undefined;
			}
			
			break;
	}
	
	return restriction_struct;
}

ProcessViolation(Dvar, Value, RestrictionStruct)
{
	//log violation
}
//----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------