#include maps\mp\_utility;
#include maps\mp\gametypes\_hud_util;
main()
{
	if(GetDvar( #"mapname") == "mp_background")
		return;
	
	maps\mp\gametypes\_globallogic::init();
	maps\mp\gametypes\_callbacksetup::SetupCallbacks();
	maps\mp\gametypes\_globallogic::SetupCallbacks();
	
	//Functions adjusts round win limit based on round limit
	level win_limit_logic();

	current_overtime = gm\Variables::GetGMVar("overtime", 0);
	if (current_overtime == 0)
	{
		maps\mp\gametypes\_globallogic_utils::registerTimeLimitDvar( level.gameType, 10, 0, 1440 );
		maps\mp\gametypes\_globallogic_utils::registerScoreLimitDvar( level.gameType, 7500, 0, 50000 );
		maps\mp\gametypes\_globallogic_utils::registerRoundLimitDvar( level.gameType, 1, 0, 10 );
		maps\mp\gametypes\_globallogic_utils::registerRoundWinLimitDvar( level.gameType, 0, 0, 10 );
		maps\mp\gametypes\_globallogic_utils::registerNumLivesDvar( level.gameType, 0, 0, 10 );
		maps\mp\gametypes\_globallogic_utils::registerRoundSwitchDvar( level.gameType, 1, 0, 9 );
	}
	else
	{
		gm\Overtime::InitDvars();
		
		gm\Overtime::RegisterTimeLimitDvar( level.gameType, 10, 0, 1440 );
		gm\Overtime::RegisterScoreLimitDvar( level.gameType, 7500, 0, 50000 );
		gm\Overtime::RegisterRoundLimitDvar( level.gameType, 1, 0, 10 );
		gm\Overtime::RegisterNumLivesDvar( level.gameType, 0, 0, 10 );
		gm\Overtime::RegisterRoundSwitchDvar( level.gameType, 1, 0, 9 );
	}

	maps\mp\gametypes\_weapons::registerGrenadeLauncherDudDvar( level.gameType, 10, 0, 1440 );
	maps\mp\gametypes\_weapons::registerThrownGrenadeDudDvar( level.gameType, 0, 0, 1440 );
	maps\mp\gametypes\_weapons::registerKillstreakDelay( level.gameType, 0, 0, 1440 );
	maps\mp\gametypes\_globallogic::registerFriendlyFireDelay( level.gameType, 15, 0, 1440 );
	if (gm\Variables::GetGMVar("gm_" + level.gameType + "_round_based_scoring", true))
	{
		level.scoreRoundBased = true;
		level.scoringLookup = "roundswon";
	}
	else
	{
		level.scoreRoundBased = false;
		level.scoringLookup = "teamScores";		
	}
		
	level.teamBased = true;
	level.onStartGameType = ::onStartGameType;
	level.onSpawnPlayer = ::onSpawnPlayer;
	level.onSpawnPlayerUnified = ::onSpawnPlayerUnified;
	level.onRoundEndGame = ::onRoundEndGame;
	level.onRoundSwitch = ::onRoundSwitch;
	level.onPointsBasedOvertime = ::onPointsBasedOvertime;

	game["dialog"]["gametype"] = "tdm_start";
	game["dialog"]["gametype_hardcore"] = "hctdm_start";
	game["dialog"]["offense_obj"] = "generic_boost";
	game["dialog"]["defense_obj"] = "generic_boost";
	
	
	setscoreboardcolumns( "kills", "deaths", "kdratio", "assists" ); 
}

//Calculate how many rounds one team needs to win in order to have a majority and win the match. 
win_limit_logic()
{
	win_limit_value = GetDvarInt(#"scr_tdm_roundlimit");

	switch( win_limit_value )
	{
	case 0:
		win_limit_value = 0;
		break;
	case 1:
		win_limit_value = 1;
		break;
	case 2:
		win_limit_value = 1;
		break;
	case 3:
		win_limit_value = 2;
		break;
	case 4:
		win_limit_value = 3;
		break;
	case 5:
		win_limit_value = 3;
		break;
	case 6:
		win_limit_value = 4;
		break;
	case 7:
		win_limit_value = 4;
		break;
	case 8:
		win_limit_value = 5;
		break;
	case 9:
		win_limit_value = 5;
		break;
	default:
		win_limit_value = 0;
		break;
	}
	SetDvar("scr_tdm_roundwinlimit", ""+win_limit_value);
}

onStartGameType()
{
	if ( !isdefined( game["switchedsides"] ) )
		game["switchedsides"] = false;
		
	setClientNameMode("auto_change");
	maps\mp\gametypes\_globallogic_ui::setObjectiveText( "allies", &"OBJECTIVES_TDM" );
	maps\mp\gametypes\_globallogic_ui::setObjectiveText( "axis", &"OBJECTIVES_TDM" );
	
	if ( level.splitscreen )
	{
		maps\mp\gametypes\_globallogic_ui::setObjectiveScoreText( "allies", &"OBJECTIVES_TDM" );
		maps\mp\gametypes\_globallogic_ui::setObjectiveScoreText( "axis", &"OBJECTIVES_TDM" );
	}
	else
	{
		maps\mp\gametypes\_globallogic_ui::setObjectiveScoreText( "allies", &"OBJECTIVES_TDM_SCORE" );
		maps\mp\gametypes\_globallogic_ui::setObjectiveScoreText( "axis", &"OBJECTIVES_TDM_SCORE" );
	}
	maps\mp\gametypes\_globallogic_ui::setObjectiveHintText( "allies", &"OBJECTIVES_TDM_HINT" );
	maps\mp\gametypes\_globallogic_ui::setObjectiveHintText( "axis", &"OBJECTIVES_TDM_HINT" );
	
	level.spawnMins = ( 0, 0, 0 );
	level.spawnMaxs = ( 0, 0, 0 );
	maps\mp\gametypes\_spawnlogic::placeSpawnPoints( "mp_tdm_spawn_allies_start" );
	maps\mp\gametypes\_spawnlogic::placeSpawnPoints( "mp_tdm_spawn_axis_start" );
	maps\mp\gametypes\_spawnlogic::addSpawnPoints( "allies", "mp_tdm_spawn" );
	maps\mp\gametypes\_spawnlogic::addSpawnPoints( "axis", "mp_tdm_spawn" );
	maps\mp\gametypes\_spawning::updateAllSpawnPoints();
	level.spawn_axis_start= maps\mp\gametypes\_spawnlogic::getSpawnpointArray("mp_tdm_spawn_axis_start");
	level.spawn_allies_start= maps\mp\gametypes\_spawnlogic::getSpawnpointArray("mp_tdm_spawn_allies_start");
	
	level.mapCenter = maps\mp\gametypes\_spawnlogic::findBoxCenter( level.spawnMins, level.spawnMaxs );
	setMapCenter( level.mapCenter );
	spawnpoint = maps\mp\gametypes\_spawnlogic::getRandomIntermissionPoint();
	setDemoIntermissionPoint( spawnpoint.origin, spawnpoint.angles );
	
	allowed[0] = "tdm";
	
	level.displayRoundEndText = false;
	maps\mp\gametypes\_gameobjects::main(allowed);
	
	
	maps\mp\gametypes\_spawning::create_map_placed_influencers();
	
	
	
	if ( !isOneRound() )
	{
		level.displayRoundEndText = true;
		if( isScoreRoundBased() )
		{
			maps\mp\gametypes\_globallogic_score::resetTeamScores();
		}
	}
}
onSpawnPlayerUnified()
{
	self.usingObj = undefined;
	
	if ( level.useStartSpawns && !level.inGracePeriod )
	{
		level.useStartSpawns = false;
	}
	
	maps\mp\gametypes\_spawning::onSpawnPlayer_Unified();
}
onSpawnPlayer()
{
	pixbeginevent("TDM:onSpawnPlayer");
	self.usingObj = undefined;

	spawnteam = self.pers["team"];
	if ( game["switchedsides"] )
		spawnteam = getOtherTeam( spawnteam );
		
	if ( level.inGracePeriod )
	{
		spawnPoints = maps\mp\gametypes\_spawnlogic::getSpawnpointArray( "mp_tdm_spawn_" + spawnteam + "_start" );
		
		if ( !spawnPoints.size )
			spawnPoints = maps\mp\gametypes\_spawnlogic::getSpawnpointArray( "mp_sab_spawn_" + spawnteam + "_start" );
			
		if ( !spawnPoints.size )
		{
			spawnPoints = maps\mp\gametypes\_spawnlogic::getTeamSpawnPoints( spawnteam );
			spawnPoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_NearTeam( spawnPoints );
		}
		else
		{
			spawnPoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_Random( spawnPoints );
		}		
	}
	else
	{
		spawnPoints = maps\mp\gametypes\_spawnlogic::getTeamSpawnPoints( spawnteam );
		spawnPoint = maps\mp\gametypes\_spawnlogic::getSpawnpoint_NearTeam( spawnPoints );
	}
	
	self spawn( spawnPoint.origin, spawnPoint.angles, "tdm" );
	pixendevent();
}
onEndGame( winningTeam )
{
	if (level.scoreRoundBased)
	{
		if ( isdefined( winningTeam ) && (winningTeam == "allies" || winningTeam == "axis") )
			[[level._setTeamScore]]( winningTeam, [[level._getTeamScore]]( winningTeam ) + 1 );	
	}
}
onRoundEndGame( roundWinner )
{
	if ( game[level.scoringLookup]["allies"] == game[level.scoringLookup]["axis"] )
		winner = "tie";
	else if ( game[level.scoringLookup]["axis"] > game[level.scoringLookup]["allies"] )
		winner = "axis";
	else
		winner = "allies";
	
	return winner;
}
onScoreCloseMusic()
{
    while( !level.gameEnded )
    {
        axisScore = [[level._getTeamScore]]( "axis" );
	    alliedScore = [[level._getTeamScore]]( "allies" );
	    scoreLimit = level.scoreLimit;
	    scoreThreshold = scoreLimit * .1;
	    scoreDif = abs(axisScore - alliedScore);
	    scoreThresholdStart = abs(scoreLimit - scoreThreshold);
	    scoreLimitCheck = scoreLimit - 10;
        
        if (alliedScore > axisScore)
	    {
		    currentScore = alliedScore;
	    }		
	    else
	    {
		    currentScore = axisScore;
	    }
        
        if ( scoreDif <= scoreThreshold && scoreThresholdStart <= currentScore )
	    {
		    
		    thread maps\mp\gametypes\_globallogic_audio::set_music_on_team( "TIME_OUT", "both" );
		    thread maps\mp\gametypes\_globallogic_audio::actionMusicSet();
		    return;
	    }
        
        wait(.5);
    }
}

onRoundSwitch()
{
	if ( !isdefined( game["switchedsides"] ) )
		game["switchedsides"] = false;
	
	[[level._setTeamScore]]( "allies", game[level.scoringLookup]["allies"] );
	[[level._setTeamScore]]( "axis", game[level.scoringLookup]["axis"] );
		
	level.inOvertime = false;

	if (level.scoreRoundBased)
	{	
		level.inOvertime = islastround();
	}
	else if (game["roundsplayed"] >= level.roundLimit)
	{	
		level.inOvertime = true;
	}
	
	if( level.inOvertime )
	{
		// overtime! flipping a coin to see if we switch again
		// could figure out which rounds the "best" team did best on and then use that
		if (randomint(2) == 0)
		{
			game["switchedsides"] = !game["switchedsides"];
		}
		else
		{
			level.halftimeSubCaption = "";
		}
		level.halftimeType = "overtime";

		// force this to be the last round
		level.forcedEnd = true;		
	}
	else
	{
		level.halftimeType = "halftime";
		game["switchedsides"] = !game["switchedsides"];
	}
	
	if (gm\Variables::GetGMVar("gm_readyup_enabled", false))
		gm\Variables::SetGMVar("gm_readyup_active", true);
}

onPointsBasedOvertime()
{
	return true;
}
